<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Services\GolfManagerService;
use Illuminate\Support\Facades\Auth;

class UserController extends Controller
{
    public function index()
    {
        return GolfManagerService::searchUsers(request('search'))
            ->filter(function ($user) {
                return $user['id'] != session('user_meta', ['id' => null])['id'];
            })
            ->map(function ($user) {
            return [
                'id' => $user['id'],
                'label' => $user['name'],
            ];
        })->values();
    }
}
