<?php

namespace App\Http\Controllers\Booking;

use App\Http\Controllers\Controller;
use App\Http\Requests\SlotRequest;
use App\Services\BookingSession;
use Illuminate\Support\Facades\Redirect;

class BookingController extends Controller
{
    public function store(SlotRequest $request)
    {
        BookingSession::create($request->all());

        return Redirect::route('booking.guests.index', [
            'booking' => session('booking.id'),
        ]);
    }

    public function update()
    {
        $booking = BookingSession::get();

        $booking->update(request()->all());

        return Redirect::back();
    }
}
