<?php

namespace App\Http\Controllers\Booking;

use App\Http\Controllers\Controller;
use App\Services\BookingSession;
use App\Services\GolfManagerService;
use Illuminate\Support\Facades\Redirect;
use Inertia\Inertia;

class FoodController extends Controller
{
    public function index()
    {
        if (!$booking = BookingSession::get()) {
            return Redirect::route('availability.index');
        }

        $products = GolfManagerService::getProducts();

        return Inertia::render('Booking/Food', [
            'food' => fn() => $products->filter(function ($product) {
                return $product['customfields_wharehouse'] == 'Food';
            })->values(),
            'beverages' => fn() => $products->filter(function ($product) {
                return $product['customfields_wharehouse'] == 'Beverage';
            })->values(),
        ]);
    }

    public function store()
    {
        $booking = BookingSession::get();

        $booking = $booking->update(request()->only(['products']));

        return Redirect::route('booking.complete.index', [
            'booking' => session('booking.id'),
        ]);
    }
}
