<?php

namespace App\Http\Controllers\Booking;

use App\Http\Controllers\Controller;
use App\Services\BookingSession;
use App\Services\GolfManagerService;
use Illuminate\Support\Facades\Redirect;
use Inertia\Inertia;

class HireController extends Controller
{
    public function index()
    {
        $bookingProducts = GolfManagerService::getBookingProducts();

        $clubProduct = $bookingProducts->first(function ($bookingProduct) {
            return $bookingProduct['name'] === '18 Hole Rental clubs';
        });

        return Inertia::render('Booking/Hire', [
            'club_cost' => $clubProduct ? $clubProduct['price'] : 15000,
        ]);
    }

    public function store()
    {
        $booking = BookingSession::get();

        $booking = $booking->update(request()->only(['products']));

        return Redirect::route('booking.food.index', [
            'booking' => session('booking.id'),
        ]);
    }
}
