<?php

namespace App\Jobs;

use App\Models\User;
use App\Services\ThawaniService;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class AddUserToThawani implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected User $user;

    public function __construct($user)
    {
        $this->user = $user;
    }

    public function handle()
    {
        $this->user->thawani_id = ThawaniService::createCustomer($this->user) ?? null;
        $this->user->save();
    }
}
