<?php

namespace App\Jobs;

use App\Mail\FoodOrder;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Mail;

class SendFoodOrderEmail implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected $booking;
    protected $user;

    public function __construct($booking, $user)
    {
        $this->booking = $booking;
        $this->user = $user;
    }

    public function handle()
    {
        Mail::to(config('mail.to.catering'))->send(new FoodOrder($this->booking, $this->user));
    }
}
