<?php

namespace App\Jobs;

use App\Mail\NewMembership;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Mail;

class SendMembershipEmail implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected $application;

    public function __construct($application)
    {
        $this->application = $application;
    }

    public function handle()
    {
        Mail::to(config('mail.to.admin'))->send(new NewMembership($this->application));
    }
}
