<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Storage;

class NewMembership extends Mailable
{
    use Queueable, SerializesModels;

    public $application;

    public function __construct($application)
    {
        $this->application = $application;
    }

    public function build()
    {
        $files = Storage::disk('local')->files('/' . $this->application['id']);

        $mail = $this->view('emails.membership.success');

        foreach ($files as $file) {
            $mail->attachFromStorage('/' . $file);
        }

        Storage::deleteDirectory('/'. $this->application['id']);

        return $mail;
    }
}
