<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    protected $fillable = [
        'name',
        'email',
        'golf_manager_id',
        'thawani_id',
        'phone',
    ];

    protected $hidden = [
        'password',
        'remember_token',
    ];

    protected $appends = [
        'type',
    ];

    public function getTypeAttribute()
    {
        return $this->id == 1 ? 'Guest' : 'Member';
    }

    public function isGuest()
    {
        return $this->type == 'Guest';
    }
}
