# Contributing

Thank you for your interest in contributing to Maizzle!

Please take a moment to review this document **before submitting a pull request**.

## Pull requests

Please [ask first](https://github.com/maizzle/framework/issues) before starting work on any significant new features.

## Coding standards

Our code formatting rules are defined in [xo.config.js](https://github.com/maizzle/framework/blob/master/xo.config.js). You can check your code against these standards by running:

```sh
npm run style
```

To automatically fix any style violations in your code, you can run:

```sh
npm run style --fix
```

## Running tests

You can run the test suite using the following command:

```sh
npm test
```

Please make sure that the tests are passing when submitting a pull request. If you're adding new features to Maizzle, please include tests.
