import React from 'react';
import { render } from 'react-dom';
import { createInertiaApp } from '@inertiajs/inertia-react';
import './styles/styles.css';
import { InertiaProgress } from '@inertiajs/progress'

import { Settings } from "luxon";

Settings.defaultZoneName = "Asia/Muscat";
Settings.defaultZone = "Asia/Muscat";

InertiaProgress.init({
  color: '#14133B',
});

const pages = import.meta.glob('./pages/**/*.jsx');

createInertiaApp({
  resolve: (name) => pages[`./pages/${name}.jsx`]().then((module) => module.default),
  setup({ el, App, props }) {
    render(<App {...props} />, el)
  },
})
