import React from 'react';

export default function Checkbox({
  id,
  name,
  label,
  className,
  onChange,
  disabled = false,
}) {
  return (
    <div className={`col-span-4 flex items-center space-x-2 ${className}`}>
      <input
        disabled={disabled}
        onChange={onChange}
        id={id}
        name={name}
        type="radio"
        className={`h-4 w-4 rounded-full ${!disabled ? 'text-green-500 focus:ring-green-500 cursor-pointer' : 'text-gray-200 focus:ring-green-200'}`}
      />
      <label className={`${!disabled ? 'cursor-pointer' : 'text-gray-200 focus:ring-green-200'}`} htmlFor={id}>{label}</label>
    </div>
  )
}
