import React from 'react';
import { InertiaLink } from '@inertiajs/inertia-react';

export default function NavStepItem({ children, step, href, active, completed, visible = true }) {
  return (
    <li className="cursor-pointer flex items-center">
      <div className={
        `flex h-8 w-8 rounded-full items-center justify-center mr-4
          ${!active && !completed && 'text-blue-900 border border-blue-900'}
          ${active && !completed && 'bg-blue-900 text-white'}
          ${completed && 'bg-green-500 text-white'}`
      }>
        {step}
      </div>
      <InertiaLink href={href} className={
        `tracking-widest text-xs leading-4 uppercase
          ${completed ? 'text-green-500': 'text-blue-900'}`
      }>
        { children }
      </InertiaLink>
    </li>
  )
}
