import React from 'react';

export default function Counter({
  onAdd,
  onSubtract,
  value,
  min
}) {

  return (
    <div className="flex items-center justify-between h-8 mt-[3px] first:mt-0 ml-auto md:ml-0">
      <button
        className={`text-green-500 ${((value || 0) <= (min || 0)) && 'opacity-40'}`}
        onClick={onSubtract}
      >
        <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <circle cx="8" cy="8" r="7.5" stroke="currentColor"/>
          <path d="M5 8H11" stroke="currentColor" strokeLinecap="round" strokeLinejoin="round"/>
        </svg>
      </button>
      <div className="min-w-[32px] md:min-w-[48px] text-center">{value || 0}</div>
      <button className="text-green-500" onClick={onAdd}>
        <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <circle cx="8" cy="8" r="7.5" stroke="currentColor"/>
          <path d="M8 5V11" stroke="currentColor" strokeLinecap="round" strokeLinejoin="round"/>
          <path d="M5 8H11" stroke="currentColor" strokeLinecap="round" strokeLinejoin="round"/>
        </svg>
      </button>
    </div>
  )
}
