import React from 'react';
import { useEffect } from 'react';
import Alpha from '../../components/typography/Alpha';
import Main from '../../layouts/Main';

const Success = ({ application }) => {
  return (
    <div className="flex flex-col w-full h-screen">
      <div className="relative h-1/3 w-full flex justify-center">
        <img src="/img/background-course.jpg" className="z-0 absolute w-full h-full object-cover" />
        <div className="max-w-2xl w-full flex justify-end items-end pb-8 relative px-[15px]">
          <Alpha className="text-white">Your membership application was sent.</Alpha>
        </div>
      </div>

      <main className="flex justify-center flex-1 w-full py-16 px-[15px]">
        <div className="max-w-2xl flex flex-col space-y-4">
          <p>Thank you {application.first_name} {application.last_name} for applying for a membership at Al Mouj Golf. Your application was sent to our membership team who will review and reach out to you through the contact details specified on the form.</p>
          <p>In the case of a rejected application, the team will contact you to co-ordinate the refund.</p>
          <a href="https://www.almoujgolf.com/" className="cursor-pointer bg-green-500 py-4 px-8 text-white flex justify-between col-span-3">
            Back to homepage
            <svg xmlns="http://www.w3.org/2000/svg" className="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
              <path strokeLinecap="round" strokeLinejoin="round" strokeWidth="2" d="M14 5l7 7m0 0l-7 7m7-7H3" />
            </svg>
          </a>
        </div>
      </main>
    </div>
  )
}

Success.layout = page => <Main width='full' children={page} />

export default Success

