import React from 'react';
import Alpha from "../../components/typography/Alpha";
import Input from '../../components/input';
import Main from '../../layouts/Main';
import { useForm, usePage } from '@inertiajs/inertia-react';

const Index = () => {
  const { flash } = usePage().props
  const { data, setData, post, processing, errors } = useForm({
    email: '',
  })

  async function submit(e) {
    e.preventDefault()
    post('/password')
  }

  return (
    <section className="bg-gray-100 h-full p-8 flex justify-center items-center">
      <div className="flex bg-white w-[1088px] h-[572px]">
        <form onSubmit={submit} className="max-w-[384px] m-16">
          <Alpha>Reset your password</Alpha>
          <p className="text-gray-500 mb-8 mt-6">To reset your password, please enter your email below and we will send you a secure link to create a new password.</p>

          {flash?.message && <p className="text-green-500 mb-8 mt-6">{flash.message}</p>}

          {!flash?.message && <>
            <Input value={data.email} onChange={e => setData('email', e.target.value)} name="email" label="EMAIL ADDRESS *" />

            <button className="btn btn--green w-[240px] mt-10 justify-center"><span>Submit</span></button>
          </>}

        </form>
      </div>
    </section>
  )
}

Index.layout = page => <Main width='full' children={page} />

export default Index
