import React, { useEffect } from 'react';
import Alpha from "../../components/typography/Alpha";
import Input from '../../components/input';
import Main from '../../layouts/Main';
import { useForm } from '@inertiajs/inertia-react';

const Reset = ({ token, email }) => {
  const { data, setData, patch, processing, errors } = useForm({
    email,
    password: '',
    password_confirmation: '',
    token,
  })

  useEffect(() => {
  }, [])

  async function submit(e) {
    e.preventDefault()
    patch(`/password/${token}`)
  }

  return (
    <section className="bg-gray-100 h-full p-8 flex justify-center items-center">
      <div className="flex bg-white w-[1088px] h-[572px]">
        <form onSubmit={submit} className="max-w-[384px] m-16">
          <Alpha>Set your new password</Alpha>
          <p className="mt-6">Minimum 8 characters.</p>
          <div className="hidden">
            <Input value={data.email} onChange={e => setData('email', e.target.value)} name="email" />
            <Input value={data.token} onChange={e => setData('token', e.target.value)} name="token" />
          </div>

          <Input inputWrapperStyle={'mt-16'} type="password" value={data.password} onChange={e => setData('password', e.target.value)} name="password" label="PASSWORD *" />
          <Input inputWrapperStyle={'mt-16'} type="password" value={data.password_confirmation} onChange={e => setData('password_confirmation', e.target.value)} name="password_confirmation" label="RE-ENTER PASSWORD *" />
          {errors && errors.password && <p className="text-red-error mt-2">{ errors.password }</p>}
          <button className="btn btn--green w-[240px] mt-10 justify-center"><span>Set new password</span></button>
        </form>
      </div>
    </section>
  )
}

Reset.layout = page => <Main width='full' children={page} />

export default Reset
