<?php

use App\Http\Controllers\Booking\BookingController;
use App\Http\Controllers\Booking\FoodController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\AvailabilityController;
use App\Http\Controllers\Booking\CompleteController;
use App\Http\Controllers\Booking\GuestController;
use App\Http\Controllers\Booking\HireController;
use App\Http\Controllers\Booking\SuccessController;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\PasswordController;
use App\Http\Controllers\Application\DeclarationController;
use App\Http\Controllers\Application\DetailsController;
use App\Http\Controllers\Application\SuccessController as ApplicationSuccessController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/login', [LoginController::class, 'index'])->name('login');
Route::post('/login/guest', [AuthController::class, 'guest'])->name('login.guest');
Route::post('/login', [AuthController::class, 'login'])->name('auth.login');
Route::post('/logout', [AuthController::class, 'logout'])->name('auth.logout');

Route::get('/signup', [DetailsController::class, 'index'])->name('signup.index');

Route::post('/signup', [DetailsController::class, 'store'])->name('signup.store');
Route::get('/signup/declaration', [DeclarationController::class, 'index'])->name('signup.declaration.index');
Route::post('/signup/declaration', [DeclarationController::class, 'store'])->name('signup.declaration.store');
Route::get('/signup/success', [ApplicationSuccessController::class, 'index'])->name('signup.success.index');

Route::resource('password', PasswordController::class);

Route::middleware('auth')->group(function () {
    Route::get('/', [AvailabilityController::class, 'index'])->name('availability.index');

    Route::resource('booking', BookingController::class);

    Route::middleware('has.booking')->group(function () {
        Route::resource('booking.hire', HireController::class);
        Route::resource('booking.guests', GuestController::class);
        Route::resource('booking.food', FoodController::class);
        Route::resource('booking.success', SuccessController::class);
        Route::resource('booking.complete', CompleteController::class);
    });
});
