<?php

namespace Tests\Unit;

use Illuminate\Foundation\Testing\DatabaseMigrations;
use Illuminate\Support\Facades\Auth;
use Tests\TestCase;

class AuthControllerTest extends TestCase
{
    use DatabaseMigrations;

    /**
     * Can log in as an Al Mouj member
     *
     * @test
     */
    public function can_login_as_a_member()
    {
        $response = $this->post('/login', [
            'email' => 'test@parall.ax',
            'password' => 'password',
        ]);

        $response->assertStatus(302);
        $response->assertRedirect(route('availability.index'));
    }

    /**
     * Can log in as an Al Mouj member
     *
     * @test
     */
    public function can_login_as_a_guest()
    {
        $response = $this->post('/login/guest');

        $response->assertStatus(302);
        $response->assertRedirect(route('availability.index'));
    }

    /**
     * Can log in as an Al Mouj member
     *
     * @test
     */
    public function can_logout()
    {
        $response = $this->post('/logout');

        $this->assertNull(Auth::user());
        $this->assertNull(session('booking', null));
    }
}
