import { defineConfig } from "vite";
import reactRefresh from '@vitejs/plugin-react-refresh';
import dynamicImportVariables from "@rollup/plugin-dynamic-import-vars";
import path from 'path';

export default defineConfig({
    publicDir: false,
    build: {
      outDir: path.resolve(__dirname, 'public'),
      emptyOutDir: false,
      manifest: true,
      rollupOptions: {
        input: 'resources/js/app.jsx',
        plugins: [
          dynamicImportVariables(),
        ]
      },
    },
    plugins: [
      reactRefresh()
    ],
})
