/**
 * @name email-comb
 * @fileoverview Remove unused CSS from email templates
 * @version 5.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/email-comb/}
 */

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).emailComb={})}(this,(function(e){"use strict";
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 3.14.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 7.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
function t(e){return e&&"object"==typeof e&&!Array.isArray(e)}function r(e){return"string"==typeof e}const n={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},i=e=>e+1;function o(e,t,r,o,s=!1,l=i){const a="function"==typeof r?r():r;if(+t<0&&s&&"EOL"===a)return a;const u={...n,...o};if(t>=e.length&&!s)return!1;let c=s?1:r.length,h=0,f=!1,g=!1,p=!1,d=u.maxMismatches,m=t,y=!1,T=!1,v=!1;function b(){return 1===h&&d<u.maxMismatches-1}for(;e[m];){const t=l(m);if(u.trimBeforeMatching&&""===e[m].trim()){if(!e[t]&&s&&"EOL"===r)return!0;m=l(m);continue}if(u&&!u.i&&u.trimCharsBeforeMatching&&u.trimCharsBeforeMatching.includes(e[m])||u&&u.i&&u.trimCharsBeforeMatching&&u.trimCharsBeforeMatching.map((e=>e.toLowerCase())).includes(e[m].toLowerCase())){if(s&&"EOL"===r&&!e[t])return!0;m=l(m);continue}const n=t>m?r[r.length-c]:r[c-1];if(!u.i&&e[m]===n||u.i&&e[m].toLowerCase()===n.toLowerCase()){if(y||(y=!0),p||(p=!0),c===r.length){if(T=!0,d!==u.maxMismatches)return!1}else 1===c&&(v=!0);if(c-=1,h++,b())return!1;if(!c)return(h!==r.length||d===u.maxMismatches||!f)&&m}else{if(f||h||(f=!0),!(u.maxMismatches&&d&&m))return!(0!==m||1!==c||u.lastMustMatch||!p)&&0;d-=1;for(let n=0;n<=d;n++){const i=t>m?r[r.length-c+1+n]:r[c-2-n],o=e[l(m)];if(i&&(!u.i&&e[m]===i||u.i&&e[m].toLowerCase()===i.toLowerCase())&&(!u.firstMustMatch||c!==r.length)){if(h++,b())return!1;c-=2,y=!0;break}if(o&&i&&(!u.i&&o===i||u.i&&o.toLowerCase()===i.toLowerCase())&&(!u.firstMustMatch||c!==r.length)){if(!h&&!u.hungry)return!1;c-=1,y=!0;break}if(void 0===i&&d>=0&&y&&(!u.firstMustMatch||T)&&(!u.lastMustMatch||v))return m}y||(g=m)}if(!1!==g&&g!==m&&(g=!1),c<1)return m;m=l(m)}return c>0?!(!s||"EOL"!==a)||!!(u&&u.maxMismatches>=c&&p)&&(g||0):void 0}function s(e,i,s,l,a){if(t(a)&&Object.prototype.hasOwnProperty.call(a,"trimBeforeMatching")&&"boolean"!=typeof a.trimBeforeMatching)throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(a.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);const u={...n,...a};var c;if("string"==typeof u.trimCharsBeforeMatching&&(u.trimCharsBeforeMatching="string"==typeof(c=u.trimCharsBeforeMatching)?c.length?[c]:[]:c),u.trimCharsBeforeMatching=u.trimCharsBeforeMatching.map((e=>r(e)?e:String(e))),!r(i))return!1;if(!i.length)return!1;if(!Number.isInteger(s)||s<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof s}, equal to:\n${JSON.stringify(s,null,4)}`);let h,f;if(r(l))h=[l];else if(Array.isArray(l))h=l;else if(l){if("function"!=typeof l)throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof l}, equal to:\n${JSON.stringify(l,null,4)}`);h=[],h.push(l)}else h=l;if(a&&!t(a))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof a}", and equal to:\n${JSON.stringify(a,null,4)}`);let g=0,p="";if(u&&u.trimCharsBeforeMatching&&u.trimCharsBeforeMatching.some(((e,t)=>e.length>1&&(g=t,p=e,!0))))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${g} is longer than 1 character, ${p.length} (equals to ${p}). Please split it into separate characters and put into array as separate elements.`);if(!h||!Array.isArray(h)||Array.isArray(h)&&!h.length||Array.isArray(h)&&1===h.length&&r(h[0])&&!h[0].trim()){if("function"==typeof u.cb){let t,r=s;if("matchLeftIncl"!==e&&"matchRight"!==e||(r+=1),"L"===e[5])for(let e=r;e--;){const r=i[e];if((!u.trimBeforeMatching||u.trimBeforeMatching&&void 0!==r&&r.trim())&&(!u.trimCharsBeforeMatching||!u.trimCharsBeforeMatching.length||void 0!==r&&!u.trimCharsBeforeMatching.includes(r))){t=e;break}}else if(e.startsWith("matchRight"))for(let e=r;e<i.length;e++){const r=i[e];if((!u.trimBeforeMatching||u.trimBeforeMatching&&r.trim())&&(!u.trimCharsBeforeMatching||!u.trimCharsBeforeMatching.length||!u.trimCharsBeforeMatching.includes(r))){t=e;break}}if(void 0===t)return!1;const n=i[t],o=t+1;let l="";return o&&o>0&&(l=i.slice(0,o)),"L"===e[5]?u.cb(n,l,t):(t&&t>0&&(l=i.slice(t)),u.cb(n,l,t))}let t="";throw a||(t=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${t}`)}for(let t=0,r=h.length;t<r;t++){f="function"==typeof h[t];const r=h[t];let n,l,a="",c=s;"matchRight"===e?c+=1:"matchLeft"===e&&(c-=1);const g=o(i,c,r,u,f,(t=>"L"===e[5]?t-1:t+1));if(g&&f&&"function"==typeof r&&"EOL"===r())return!(!r()||u.cb&&!u.cb(n,a,l))&&r();if(Number.isInteger(g)&&(l=e.startsWith("matchLeft")?g-1:g+1,a="L"===e[5]?i.slice(0,g):i.slice(l)),l<0&&(l=void 0),i[l]&&(n=i[l]),Number.isInteger(g)&&(!u.cb||u.cb(n,a,l)))return r}return!1}function l(e,t,r,n){return s("matchLeft",e,t,r,n)}function a(e,t,r,n){return s("matchRightIncl",e,t,r,n)}function u(e,t,r,n){return s("matchRight",e,t,r,n)}
/**
 * @name regex-empty-conditional-comments
 * @fileoverview Regular expression for matching HTML empty conditional comments
 * @version 1.11.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/regex-empty-conditional-comments/}
 */var c="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};Function.prototype.toString.call(Object);var h={exports:{}};!function(e,t){var r="__lodash_hash_undefined__",n=9007199254740991,i="[object Arguments]",o="[object Boolean]",s="[object Date]",l="[object Function]",a="[object GeneratorFunction]",u="[object Map]",h="[object Number]",f="[object Object]",g="[object Promise]",p="[object RegExp]",d="[object Set]",m="[object String]",y="[object Symbol]",T="[object WeakMap]",v="[object ArrayBuffer]",b="[object DataView]",_="[object Float32Array]",w="[object Float64Array]",O="[object Int8Array]",S="[object Int16Array]",A="[object Int32Array]",C="[object Uint8Array]",I="[object Uint8ClampedArray]",L="[object Uint16Array]",$="[object Uint32Array]",M=/\w*$/,W=/^\[object .+?Constructor\]$/,R=/^(?:0|[1-9]\d*)$/,j={};j[i]=j["[object Array]"]=j[v]=j[b]=j[o]=j[s]=j[_]=j[w]=j[O]=j[S]=j[A]=j[u]=j[h]=j[f]=j[p]=j[d]=j[m]=j[y]=j[C]=j[I]=j[L]=j[$]=!0,j["[object Error]"]=j[l]=j[T]=!1;var x="object"==typeof self&&self&&self.Object===Object&&self,F="object"==typeof c&&c&&c.Object===Object&&c||x||Function("return this")(),k=t&&!t.nodeType&&t,E=k&&e&&!e.nodeType&&e,H=E&&E.exports===k;function N(e,t){return e.set(t[0],t[1]),e}function P(e,t){return e.add(t),e}function B(e,t,r,n){var i=-1,o=e?e.length:0;for(n&&o&&(r=e[++i]);++i<o;)r=t(r,e[i],i,e);return r}function D(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}function J(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}function q(e,t){return function(r){return e(t(r))}}function z(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}var U,G=Array.prototype,V=Function.prototype,Z=Object.prototype,Y=F["__core-js_shared__"],K=(U=/[^.]+$/.exec(Y&&Y.keys&&Y.keys.IE_PROTO||""))?"Symbol(src)_1."+U:"",Q=V.toString,X=Z.hasOwnProperty,ee=Z.toString,te=RegExp("^"+Q.call(X).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),re=H?F.Buffer:void 0,ne=F.Symbol,ie=F.Uint8Array,oe=q(Object.getPrototypeOf,Object),se=Object.create,le=Z.propertyIsEnumerable,ae=G.splice,ue=Object.getOwnPropertySymbols,ce=re?re.isBuffer:void 0,he=q(Object.keys,Object),fe=Ee(F,"DataView"),ge=Ee(F,"Map"),pe=Ee(F,"Promise"),de=Ee(F,"Set"),me=Ee(F,"WeakMap"),ye=Ee(Object,"create"),Te=De(fe),ve=De(ge),be=De(pe),_e=De(de),we=De(me),Oe=ne?ne.prototype:void 0,Se=Oe?Oe.valueOf:void 0;function Ae(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Ce(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Ie(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Le(e){this.__data__=new Ce(e)}function $e(e,t){var r=qe(e)||function(e){return function(e){return function(e){return!!e&&"object"==typeof e}(e)&&ze(e)}(e)&&X.call(e,"callee")&&(!le.call(e,"callee")||ee.call(e)==i)}(e)?function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}(e.length,String):[],n=r.length,o=!!n;for(var s in e)!t&&!X.call(e,s)||o&&("length"==s||Pe(s,n))||r.push(s);return r}function Me(e,t,r){var n=e[t];X.call(e,t)&&Je(n,r)&&(void 0!==r||t in e)||(e[t]=r)}function We(e,t){for(var r=e.length;r--;)if(Je(e[r][0],t))return r;return-1}function Re(e,t,r,n,c,g,T){var W;if(n&&(W=g?n(e,c,g,T):n(e)),void 0!==W)return W;if(!Ve(e))return e;var R=qe(e);if(R){if(W=function(e){var t=e.length,r=e.constructor(t);t&&"string"==typeof e[0]&&X.call(e,"index")&&(r.index=e.index,r.input=e.input);return r}(e),!t)return function(e,t){var r=-1,n=e.length;t||(t=Array(n));for(;++r<n;)t[r]=e[r];return t}(e,W)}else{var x=Ne(e),F=x==l||x==a;if(Ue(e))return function(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}(e,t);if(x==f||x==i||F&&!g){if(D(e))return g?e:{};if(W=function(e){return"function"!=typeof e.constructor||Be(e)?{}:(t=oe(e),Ve(t)?se(t):{});var t}(F?{}:e),!t)return function(e,t){return Fe(e,He(e),t)}(e,function(e,t){return e&&Fe(t,Ze(t),e)}(W,e))}else{if(!j[x])return g?e:{};W=function(e,t,r,n){var i=e.constructor;switch(t){case v:return xe(e);case o:case s:return new i(+e);case b:return function(e,t){var r=t?xe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}(e,n);case _:case w:case O:case S:case A:case C:case I:case L:case $:return function(e,t){var r=t?xe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}(e,n);case u:return function(e,t,r){return B(t?r(J(e),!0):J(e),N,new e.constructor)}(e,n,r);case h:case m:return new i(e);case p:return function(e){var t=new e.constructor(e.source,M.exec(e));return t.lastIndex=e.lastIndex,t}(e);case d:return function(e,t,r){return B(t?r(z(e),!0):z(e),P,new e.constructor)}(e,n,r);case y:return l=e,Se?Object(Se.call(l)):{}}var l}(e,x,Re,t)}}T||(T=new Le);var k=T.get(e);if(k)return k;if(T.set(e,W),!R)var E=r?function(e){return function(e,t,r){var n=t(e);return qe(e)?n:function(e,t){for(var r=-1,n=t.length,i=e.length;++r<n;)e[i+r]=t[r];return e}(n,r(e))}(e,Ze,He)}(e):Ze(e);return function(e,t){for(var r=-1,n=e?e.length:0;++r<n&&!1!==t(e[r],r,e););}(E||e,(function(i,o){E&&(i=e[o=i]),Me(W,o,Re(i,t,r,n,o,e,T))})),W}function je(e){return!(!Ve(e)||(t=e,K&&K in t))&&(Ge(e)||D(e)?te:W).test(De(e));var t}function xe(e){var t=new e.constructor(e.byteLength);return new ie(t).set(new ie(e)),t}function Fe(e,t,r,n){r||(r={});for(var i=-1,o=t.length;++i<o;){var s=t[i],l=n?n(r[s],e[s],s,r,e):void 0;Me(r,s,void 0===l?e[s]:l)}return r}function ke(e,t){var r,n,i=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?i["string"==typeof t?"string":"hash"]:i.map}function Ee(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return je(r)?r:void 0}Ae.prototype.clear=function(){this.__data__=ye?ye(null):{}},Ae.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},Ae.prototype.get=function(e){var t=this.__data__;if(ye){var n=t[e];return n===r?void 0:n}return X.call(t,e)?t[e]:void 0},Ae.prototype.has=function(e){var t=this.__data__;return ye?void 0!==t[e]:X.call(t,e)},Ae.prototype.set=function(e,t){return this.__data__[e]=ye&&void 0===t?r:t,this},Ce.prototype.clear=function(){this.__data__=[]},Ce.prototype.delete=function(e){var t=this.__data__,r=We(t,e);return!(r<0)&&(r==t.length-1?t.pop():ae.call(t,r,1),!0)},Ce.prototype.get=function(e){var t=this.__data__,r=We(t,e);return r<0?void 0:t[r][1]},Ce.prototype.has=function(e){return We(this.__data__,e)>-1},Ce.prototype.set=function(e,t){var r=this.__data__,n=We(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},Ie.prototype.clear=function(){this.__data__={hash:new Ae,map:new(ge||Ce),string:new Ae}},Ie.prototype.delete=function(e){return ke(this,e).delete(e)},Ie.prototype.get=function(e){return ke(this,e).get(e)},Ie.prototype.has=function(e){return ke(this,e).has(e)},Ie.prototype.set=function(e,t){return ke(this,e).set(e,t),this},Le.prototype.clear=function(){this.__data__=new Ce},Le.prototype.delete=function(e){return this.__data__.delete(e)},Le.prototype.get=function(e){return this.__data__.get(e)},Le.prototype.has=function(e){return this.__data__.has(e)},Le.prototype.set=function(e,t){var r=this.__data__;if(r instanceof Ce){var n=r.__data__;if(!ge||n.length<199)return n.push([e,t]),this;r=this.__data__=new Ie(n)}return r.set(e,t),this};var He=ue?q(ue,Object):function(){return[]},Ne=function(e){return ee.call(e)};function Pe(e,t){return!!(t=null==t?n:t)&&("number"==typeof e||R.test(e))&&e>-1&&e%1==0&&e<t}function Be(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||Z)}function De(e){if(null!=e){try{return Q.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function Je(e,t){return e===t||e!=e&&t!=t}(fe&&Ne(new fe(new ArrayBuffer(1)))!=b||ge&&Ne(new ge)!=u||pe&&Ne(pe.resolve())!=g||de&&Ne(new de)!=d||me&&Ne(new me)!=T)&&(Ne=function(e){var t=ee.call(e),r=t==f?e.constructor:void 0,n=r?De(r):void 0;if(n)switch(n){case Te:return b;case ve:return u;case be:return g;case _e:return d;case we:return T}return t});var qe=Array.isArray;function ze(e){return null!=e&&function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=n}(e.length)&&!Ge(e)}var Ue=ce||function(){return!1};function Ge(e){var t=Ve(e)?ee.call(e):"";return t==l||t==a}function Ve(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function Ze(e){return ze(e)?$e(e):function(e){if(!Be(e))return he(e);var t=[];for(var r in Object(e))X.call(e,r)&&"constructor"!=r&&t.push(r);return t}(e)}e.exports=function(e){return Re(e,!0,!0)}}(h,h.exports);
/**
 * @name string-left-right
 * @fileoverview Looks up the first non-whitespace character to the left/right of a given index
 * @version 4.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-left-right/}
 */
const f=" ";function g(e,t=0){return function({str:e,idx:t=0,stopAtNewlines:r=!1,stopAtRawNbsp:n=!1}){if("string"!=typeof e||!e.length)return null;if(t&&"number"==typeof t||(t=0),!e[t+1])return null;if(e[t+1]&&(e[t+1].trim()||r&&"\n\r".includes(e[t+1])||n&&e[t+1]===f))return t+1;if(e[t+2]&&(e[t+2].trim()||r&&"\n\r".includes(e[t+2])||n&&e[t+2]===f))return t+2;for(let i=t+1,o=e.length;i<o;i++)if(e[i].trim()||r&&"\n\r".includes(e[i])||n&&e[i]===f)return i;return null}({str:e,idx:t,stopAtNewlines:!1,stopAtRawNbsp:!1})}function p(e,t=0){return function({str:e,idx:t,stopAtNewlines:r,stopAtRawNbsp:n}){if("string"!=typeof e||!e.length)return null;if(t&&"number"==typeof t||(t=0),t<1)return null;if(e[~-t]&&(e[~-t].trim()||r&&"\n\r".includes(e[~-t])||n&&e[~-t]===f))return~-t;if(e[t-2]&&(e[t-2].trim()||r&&"\n\r".includes(e[t-2])||n&&e[t-2]===f))return t-2;for(let i=t;i--;)if(e[i]&&(e[i].trim()||r&&"\n\r".includes(e[i])||n&&e[i]===f))return i;return null}({str:e,idx:t,stopAtNewlines:!1,stopAtRawNbsp:!1})}
/**
 * @name string-extract-class-names
 * @fileoverview Extracts CSS class/id names from a string
 * @version 6.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-extract-class-names/}
 */function d(e){if("string"!=typeof e)throw new TypeError(`string-extract-class-names: [THROW_ID_01] first str should be string, not ${typeof e}, currently equal to ${JSON.stringify(e,null,4)}`);const t=".# ~\\!@$%^&*()+=,/';:\"?><[]{}|`";let r;function n(e){return"string"==typeof e&&!!e.length&&(e.charCodeAt(0)>64&&e.charCodeAt(0)<91||e.charCodeAt(0)>96&&e.charCodeAt(0)<123)}let i=null;const o={res:[],ranges:[]};for(let s=0,l=e.length;s<=l;s++){null!==i&&s>=i&&(!e[s]||!e[s].trim()||t.includes(e[s]))&&(s>i+1&&(o.ranges.push([i,s]),o.res.push(`${r||""}${e.slice(i,s)}`),r&&(r=void 0)),i=null),!e[s]||null!==i||"."!==e[s]&&"#"!==e[s]||(i=s);const l=g(e,s+4);e.startsWith("class",s)&&"number"==typeof p(e,s)&&"["===e[p(e,s)]&&"number"==typeof l&&"="===e[l]&&(g(e,l)&&n(e[g(e,l)])?i=g(e,l):"'\"".includes(e[g(e,l)])&&n(e[g(e,g(e,l))])&&(i=g(e,g(e,l))),r=".");const a=g(e,s+1);e.startsWith("id",s)&&"["===e[p(e,s)]&&null!==a&&"="===e[a]&&(n(e[g(e,a)])?i=g(e,a):"'\"".includes(e[g(e,a)])&&n(e[g(e,g(e,a))])&&(i=g(e,g(e,a))),r="#")}return o.ranges.length||(o.ranges=null),o}var m={exports:{}};const y=e=>{if("string"!=typeof e)throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")},T=new Map;function v(e,t){if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter((e=>{if("string"!=typeof e){if(void 0===e)return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof e}' in the array`)}return!0}))}function b(e,t){t={caseSensitive:!1,...t};const r=e+JSON.stringify(t);if(T.has(r))return T.get(r);const n="!"===e[0];n&&(e=e.slice(1)),e=y(e).replace(/\\\*/g,"[\\s\\S]*");const i=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return i.negated=n,T.set(r,i),i}m.exports=(e,t,r)=>{if(e=v(e,"inputs"),0===(t=v(t,"patterns")).length)return[];const n="!"===t[0][0];t=t.map((e=>b(e,r)));const i=[];for(const r of e){let e=n;for(const n of t)n.test(r)&&(e=!n.negated);e&&i.push(r)}return i},m.exports.isMatch=(e,t,r)=>(e=v(e,"inputs"),0!==(t=v(t,"patterns")).length&&e.some((e=>t.every((t=>{const n=b(t,r),i=n.test(e);return n.negated?!i:i})))));var _=m.exports;
/**
 * @name array-pull-all-with-glob
 * @fileoverview Like _.pullAll but with globs (wildcards)
 * @version 5.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-pull-all-with-glob/}
 */function w(e,t,r){if(!e.length)return[];if(!e.length||!t.length)return Array.from(e);const n="string"==typeof t?[t]:Array.from(t),i={caseSensitive:!0,...r};return Array.from(e).filter((e=>!n.some((t=>_.isMatch(e,t,{caseSensitive:i.caseSensitive})))))}var O="__lodash_hash_undefined__",S=9007199254740991,A=/^\[object .+?Constructor\]$/,C="object"==typeof self&&self&&self.Object===Object&&self,I="object"==typeof c&&c&&c.Object===Object&&c||C||Function("return this")();function L(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}function $(e,t){return!!(e?e.length:0)&&function(e,t,r){if(t!=t)return function(e,t,r,n){var i=e.length,o=r+(n?1:-1);for(;n?o--:++o<i;)if(t(e[o],o,e))return o;return-1}(e,R,r);var n=r-1,i=e.length;for(;++n<i;)if(e[n]===t)return n;return-1}(e,t,0)>-1}function M(e,t,r){for(var n=-1,i=e?e.length:0;++n<i;)if(r(t,e[n]))return!0;return!1}function W(e,t){for(var r=-1,n=e?e.length:0,i=Array(n);++r<n;)i[r]=t(e[r],r,e);return i}function R(e){return e!=e}function j(e){return function(t){return e(t)}}function x(e,t){return e.has(t)}var F,k,E,H=Array.prototype,N=Function.prototype,P=Object.prototype,B=I["__core-js_shared__"],D=(F=/[^.]+$/.exec(B&&B.keys&&B.keys.IE_PROTO||""))?"Symbol(src)_1."+F:"",J=N.toString,q=P.hasOwnProperty,z=P.toString,U=RegExp("^"+J.call(q).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),G=H.splice,V=Math.max,Z=Math.min,Y=se(I,"Map"),K=se(Object,"create");function Q(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function X(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function ee(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function te(e){var t=-1,r=e?e.length:0;for(this.__data__=new ee;++t<r;)this.add(e[t])}function re(e,t){for(var r,n,i=e.length;i--;)if((r=e[i][0])===(n=t)||r!=r&&n!=n)return i;return-1}function ne(e){return!(!ae(e)||(t=e,D&&D in t))&&(le(e)||function(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}(e)?U:A).test(function(e){if(null!=e){try{return J.call(e)}catch(e){}try{return e+""}catch(e){}}return""}(e));var t}function ie(e){return function(e){return function(e){return!!e&&"object"==typeof e}(e)&&function(e){return null!=e&&function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=S}(e.length)&&!le(e)}(e)}(e)?e:[]}function oe(e,t){var r,n,i=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?i["string"==typeof t?"string":"hash"]:i.map}function se(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return ne(r)?r:void 0}function le(e){var t=ae(e)?z.call(e):"";return"[object Function]"==t||"[object GeneratorFunction]"==t}function ae(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}Q.prototype.clear=function(){this.__data__=K?K(null):{}},Q.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},Q.prototype.get=function(e){var t=this.__data__;if(K){var r=t[e];return r===O?void 0:r}return q.call(t,e)?t[e]:void 0},Q.prototype.has=function(e){var t=this.__data__;return K?void 0!==t[e]:q.call(t,e)},Q.prototype.set=function(e,t){return this.__data__[e]=K&&void 0===t?O:t,this},X.prototype.clear=function(){this.__data__=[]},X.prototype.delete=function(e){var t=this.__data__,r=re(t,e);return!(r<0)&&(r==t.length-1?t.pop():G.call(t,r,1),!0)},X.prototype.get=function(e){var t=this.__data__,r=re(t,e);return r<0?void 0:t[r][1]},X.prototype.has=function(e){return re(this.__data__,e)>-1},X.prototype.set=function(e,t){var r=this.__data__,n=re(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},ee.prototype.clear=function(){this.__data__={hash:new Q,map:new(Y||X),string:new Q}},ee.prototype.delete=function(e){return oe(this,e).delete(e)},ee.prototype.get=function(e){return oe(this,e).get(e)},ee.prototype.has=function(e){return oe(this,e).has(e)},ee.prototype.set=function(e,t){return oe(this,e).set(e,t),this},te.prototype.add=te.prototype.push=function(e){return this.__data__.set(e,O),this},te.prototype.has=function(e){return this.__data__.has(e)};var ue=(k=function(e){var t=W(e,ie);return t.length&&t[0]===e[0]?function(e,t,r){for(var n=r?M:$,i=e[0].length,o=e.length,s=o,l=Array(o),a=1/0,u=[];s--;){var c=e[s];s&&t&&(c=W(c,j(t))),a=Z(c.length,a),l[s]=!r&&(t||i>=120&&c.length>=120)?new te(s&&c):void 0}c=e[0];var h=-1,f=l[0];e:for(;++h<i&&u.length<a;){var g=c[h],p=t?t(g):g;if(g=r||0!==g?g:0,!(f?x(f,p):n(u,p,r))){for(s=o;--s;){var d=l[s];if(!(d?x(d,p):n(e[s],p,r)))continue e}f&&f.push(p),u.push(g)}}return u}(t):[]},E=V(void 0===E?k.length-1:E,0),function(){for(var e=arguments,t=-1,r=V(e.length-E,0),n=Array(r);++t<r;)n[t]=e[E+t];t=-1;for(var i=Array(E+1);++t<E;)i[t]=e[t];return i[E]=n,L(k,this,i)});
/**
 * @name string-range-expander
 * @fileoverview Expands string index ranges within whitespace boundaries until letters are met
 * @version 2.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-range-expander/}
 */const ce={str:"",from:0,to:0,ifLeftSideIncludesThisThenCropTightly:"",ifLeftSideIncludesThisCropItToo:"",ifRightSideIncludesThisThenCropTightly:"",ifRightSideIncludesThisCropItToo:"",extendToOneSide:!1,wipeAllWhitespaceOnLeft:!1,wipeAllWhitespaceOnRight:!1,addSingleSpaceToPreventAccidentalConcatenation:!1};function he(e){const t=/^[0-9a-zA-Z]+$/;function r(e){return!(!e||"string"!=typeof e)&&!e.trim()}function n(e){return"string"==typeof e}if(!e||"object"!=typeof e||Array.isArray(e)){let t;throw t=void 0===e?"but it is missing completely.":null===e?"but it was given as null.":`but it was given as ${typeof e}, equal to:\n${JSON.stringify(e,null,4)}.`,new Error(`string-range-expander: [THROW_ID_01] Input must be a plain object ${t}`)}if("object"==typeof e&&null!==e&&!Array.isArray(e)&&!Object.keys(e).length)throw new Error("string-range-expander: [THROW_ID_02] Input must be a plain object but it was given as a plain object without any keys.");if("number"!=typeof e.from)throw new Error(`string-range-expander: [THROW_ID_03] The input's "from" value opts.from, is not a number! Currently it's given as ${typeof e.from}, equal to ${JSON.stringify(e.from,null,0)}`);if("number"!=typeof e.to)throw new Error(`string-range-expander: [THROW_ID_04] The input's "to" value opts.to, is not a number! Currently it's given as ${typeof e.to}, equal to ${JSON.stringify(e.to,null,0)}`);if(e&&e.str&&!e.str[e.from]&&e.from!==e.to)throw new Error(`string-range-expander: [THROW_ID_05] The given input string opts.str ("${e.str}") must contain the character at index "from" ("${e.from}")`);if(e&&e.str&&!e.str[e.to-1])throw new Error(`string-range-expander: [THROW_ID_06] The given input string, opts.str ("${e.str}") must contain the character at index before "to" ("${e.to-1}")`);if(e.from>e.to)throw new Error(`string-range-expander: [THROW_ID_07] The given "from" index, "${e.from}" is greater than "to" index, "${e.to}". That's wrong!`);if(n(e.extendToOneSide)&&"left"!==e.extendToOneSide&&"right"!==e.extendToOneSide||!n(e.extendToOneSide)&&void 0!==e.extendToOneSide&&!1!==e.extendToOneSide)throw new Error(`string-range-expander: [THROW_ID_08] The opts.extendToOneSide value is not recogniseable! It's set to: "${e.extendToOneSide}" (${typeof e.extendToOneSide}). It has to be either Boolean "false" or strings "left" or "right"`);const i={...ce,...e};if(Array.isArray(i.ifLeftSideIncludesThisThenCropTightly)){let e,t;if(!i.ifLeftSideIncludesThisThenCropTightly.every(((r,i)=>!!n(r)||(e=i,t=r,!1))))throw new Error(`string-range-expander: [THROW_ID_09] The opts.ifLeftSideIncludesThisThenCropTightly was set to an array:\n${JSON.stringify(i.ifLeftSideIncludesThisThenCropTightly,null,4)}. Now, that array contains not only string elements. For example, an element at index ${e} is of a type ${typeof t} (equal to ${JSON.stringify(t,null,0)}).`);i.ifLeftSideIncludesThisThenCropTightly=i.ifLeftSideIncludesThisThenCropTightly.join("")}const o=i.str;let s=i.from,l=i.to;if("right"!==i.extendToOneSide&&(r(o[s-1])&&(r(o[s-2])||i.ifLeftSideIncludesThisCropItToo.includes(o[s-2]))||o[s-1]&&i.ifLeftSideIncludesThisCropItToo.includes(o[s-1])||i.wipeAllWhitespaceOnLeft&&r(o[s-1])))for(let e=s;e--;)if(!i.ifLeftSideIncludesThisCropItToo.includes(o[e])){if(o[e].trim()){s=i.wipeAllWhitespaceOnLeft||i.ifLeftSideIncludesThisCropItToo.includes(o[e+1])?e+1:e+2;break}if(0===e){s=i.wipeAllWhitespaceOnLeft?0:1;break}}if("left"!==i.extendToOneSide&&(r(o[l])&&(i.wipeAllWhitespaceOnRight||r(o[l+1]))||i.ifRightSideIncludesThisCropItToo.includes(o[l])))for(let e=l,t=o.length;e<t;e++)if(!i.ifRightSideIncludesThisCropItToo.includes(o[e])&&(o[e]&&o[e].trim()||void 0===o[e])){l=i.wipeAllWhitespaceOnRight||i.ifRightSideIncludesThisCropItToo.includes(o[e-1])?e:e-1;break}return("right"!==i.extendToOneSide&&n(i.ifLeftSideIncludesThisThenCropTightly)&&i.ifLeftSideIncludesThisThenCropTightly&&(o[s-2]&&i.ifLeftSideIncludesThisThenCropTightly.includes(o[s-2])||o[s-1]&&i.ifLeftSideIncludesThisThenCropTightly.includes(o[s-1]))||"left"!==i.extendToOneSide&&n(i.ifRightSideIncludesThisThenCropTightly)&&i.ifRightSideIncludesThisThenCropTightly&&(o[l+1]&&i.ifRightSideIncludesThisThenCropTightly.includes(o[l+1])||o[l]&&i.ifRightSideIncludesThisThenCropTightly.includes(o[l])))&&("right"!==i.extendToOneSide&&r(o[s-1])&&!i.wipeAllWhitespaceOnLeft&&(s-=1),"left"!==i.extendToOneSide&&r(o[l])&&!i.wipeAllWhitespaceOnRight&&(l+=1)),i.addSingleSpaceToPreventAccidentalConcatenation&&o[s-1]&&o[s-1].trim()&&o[l]&&o[l].trim()&&(!i.ifLeftSideIncludesThisThenCropTightly&&!i.ifRightSideIncludesThisThenCropTightly||i.ifLeftSideIncludesThisThenCropTightly&&!i.ifLeftSideIncludesThisThenCropTightly.includes(o[s-1])||!(!i.ifRightSideIncludesThisThenCropTightly||o[l]&&i.ifRightSideIncludesThisThenCropTightly.includes(o[l])))&&(t.test(o[s-1])||t.test(o[l]))?[s,l," "]:[s,l]}
/**
 * @name string-uglify
 * @fileoverview Shorten sets of strings deterministically, to be git-friendly
 * @version 1.5.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-uglify/}
 */function fe(e,t=0){return e.codePointAt(t)||0}function ge(e){const t="abcdefghijklmnopqrstuvwxyz",r="abcdefghijklmnopqrstuvwxyz0123456789",n={a:!1,b:!1,c:!1,d:!1,e:!1,f:!1,g:!1,h:!1,i:!1,j:!1,k:!1,l:!1,m:!1,n:!1,o:!1,p:!1,q:!1,r:!1,s:!1,t:!1,u:!1,v:!1,w:!1,x:!1,y:!1,z:!1},i={a:!1,b:!1,c:!1,d:!1,e:!1,f:!1,g:!1,h:!1,i:!1,j:!1,k:!1,l:!1,m:!1,n:!1,o:!1,p:!1,q:!1,r:!1,s:!1,t:!1,u:!1,v:!1,w:!1,x:!1,y:!1,z:!1},o={a:!1,b:!1,c:!1,d:!1,e:!1,f:!1,g:!1,h:!1,i:!1,j:!1,k:!1,l:!1,m:!1,n:!1,o:!1,p:!1,q:!1,r:!1,s:!1,t:!1,u:!1,v:!1,w:!1,x:!1,y:!1,z:!1},s=[];if(!Array.isArray(e)||!e.length)return e;for(let l=0,a=e.length;l<a;l++){if(e.indexOf(e[l])<l){s.push(s[e.indexOf(e[l])]);continue}const a=".#".includes(e[l][0])?e[l][0]:"",u=Array.from(e[l]).reduce(((e,t)=>e+fe(t)),0);if(".#".includes(e[l][0])&&e[l].length<4||!".#".includes(e[l][0])&&e[l].length<3){const t=e[l];if(!s.includes(t)){s.push(t),t.startsWith(".")&&2===t.length&&!1===n[t.slice(1)]?n[t.slice(1)]=!0:t.startsWith("#")&&2===t.length&&!1===i[t.slice(1)]?i[t.slice(1)]=!0:t.startsWith(".")||t.startsWith("#")||1!==t.length||!1!==o[t]||(o[t]=!0);continue}}let c=`${a}${t[u%t.length]}${r[u%r.length]}`;if(s.includes(c)){let t=c,n=0;const i=Array.from(e[l]).reduce(((e,t)=>e<200?e+fe(t):(e+fe(t))%r.length),0),o=Array.from(e[l]).map((e=>fe(e))).reduce(((e,t)=>{let r=e+t;do{r=String(r).split("").reduce(((e,t)=>e+Number.parseInt(t,10)),0)}while(r>=10);return r}),0);for(;s.includes(t);)n+=1,t+=r[i*o*n%r.length];c=t}s.push(c),c.startsWith(".")&&2===c.length&&!1===n[c.slice(1)]?n[c.slice(1)]=!0:c.startsWith("#")&&2===c.length&&!1===i[c.slice(1)]?i[c.slice(1)]=!0:c.startsWith(".")||c.startsWith("#")||1!==c.length||!1!==o[c]||(o[c]=!0)}for(let e=0,t=s.length;e<t;e++)s[e].startsWith(".")?!1===n[s[e].slice(1,2)]?(n[s[e].slice(1,2)]=s[e],s[e]=s[e].slice(0,2)):n[s[e].slice(1,2)]===s[e]&&(s[e]=s[e].slice(0,2)):s[e].startsWith("#")?!1===i[s[e].slice(1,2)]?(i[s[e].slice(1,2)]=s[e],s[e]=s[e].slice(0,2)):i[s[e].slice(1,2)]===s[e]&&(s[e]=s[e].slice(0,2)):s[e].startsWith(".")||s[e].startsWith("#")||(o[s[e].slice(0,1)]?o[s[e].slice(0,1)]===s[e]&&(s[e]=s[e].slice(0,1)):(o[s[e].slice(0,1)]=s[e],s[e]=s[e].slice(0,1)));return s}
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 4.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */const pe={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function de(e,t){if(!Array.isArray(e)||!e.length)return e;const r={...pe,...t};let n,i;if(r.strictlyTwoElementsInRangeArrays&&!e.filter((e=>e)).every(((e,t)=>2===e.length||(n=t,i=e.length,!1))))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) has not two but ${i} elements!`);if(!e.filter((e=>e)).every(((e,t)=>!(!Number.isInteger(e[0])||e[0]<0||!Number.isInteger(e[1])||e[1]<0)||(n=t,!1))))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) does not consist of only natural numbers!`);const o=e.filter((e=>e)).length**2;let s=0;return Array.from(e).filter((e=>e)).sort(((e,t)=>(r.progressFn&&(s+=1,r.progressFn(Math.floor(100*s/o))),e[0]===t[0]?e[1]<t[1]?-1:e[1]>t[1]?1:0:e[0]<t[0]?-1:1)))}
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 7.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */const me={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function ye(e,t){function r(e){return e&&"object"==typeof e&&!Array.isArray(e)}if(!Array.isArray(e)||!e.length)return null;let n;if(t){if(!r(t))throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:\n${JSON.stringify(t,null,4)} (type ${typeof t})`);if(n={...me,...t},n.progressFn&&r(n.progressFn)&&!Object.keys(n.progressFn).length)n.progressFn=null;else if(n.progressFn&&"function"!=typeof n.progressFn)throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn,null,4)}`);if(n.mergeType&&1!=+n.mergeType&&2!=+n.mergeType)throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);if("boolean"!=typeof n.joinRangesThatTouchEdges)throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges,null,4)}`)}else n={...me};const i=e.filter((e=>e)).map((e=>[...e])).filter((e=>void 0!==e[2]||e[0]!==e[1]));let o,s,l;if(o=n.progressFn?de(i,{progressFn:e=>{l=Math.floor(e/5),l!==s&&(s=l,n.progressFn(l))}}):de(i),!o)return null;const a=o.length-1;for(let e=a;e>0;e--)n.progressFn&&(l=Math.floor(78*(1-e/a))+21,l!==s&&l>s&&(s=l,n.progressFn(l))),(o[e][0]<=o[e-1][0]||!n.joinRangesThatTouchEdges&&o[e][0]<o[e-1][1]||n.joinRangesThatTouchEdges&&o[e][0]<=o[e-1][1])&&(o[e-1][0]=Math.min(o[e][0],o[e-1][0]),o[e-1][1]=Math.max(o[e][1],o[e-1][1]),void 0!==o[e][2]&&(o[e-1][0]>=o[e][0]||o[e-1][1]<=o[e][1])&&null!==o[e-1][2]&&(null===o[e][2]&&null!==o[e-1][2]?o[e-1][2]=null:null!=o[e-1][2]?2==+n.mergeType&&o[e-1][0]===o[e][0]?o[e-1][2]=o[e][2]:o[e-1][2]+=o[e][2]:o[e-1][2]=o[e][2]),o.splice(e,1),e=o.length);return o.length?o:null}
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 5.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */function Te(e,t,r){let n,i=0,o=0;if(0===arguments.length)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if("string"!=typeof e)throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(t&&!Array.isArray(t))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);if(r&&"function"!=typeof r)throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r,null,4)}`);if(!t||!t.filter((e=>e)).length)return e;n=Array.isArray(t)&&Number.isInteger(t[0])&&Number.isInteger(t[1])?[Array.from(t)]:Array.from(t);const s=n.length;let l=0;n.filter((e=>e)).forEach(((e,t)=>{if(r&&(i=Math.floor(l/s*10),i!==o&&(o=i,r(i))),!Array.isArray(e))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${t}th element not an array: ${JSON.stringify(e,null,4)}, which is ${typeof e}`);if(!Number.isInteger(e[0])){if(!Number.isInteger(+e[0])||+e[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${t}th element, array ${JSON.stringify(e,null,0)}. Its first element is not an integer, string index, but ${typeof e[0]}, equal to: ${JSON.stringify(e[0],null,4)}.`);n[t][0]=+n[t][0]}if(!Number.isInteger(e[1])){if(!Number.isInteger(+e[1])||+e[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${t}th element, array ${JSON.stringify(e,null,0)}. Its second element is not an integer, string index, but ${typeof e[1]}, equal to: ${JSON.stringify(e[1],null,4)}.`);n[t][1]=+n[t][1]}l+=1}));const a=ye(n,{progressFn:e=>{r&&(i=10+Math.floor(e/10),i!==o&&(o=i,r(i)))}}),u=Array.isArray(a)?a.length:0;if(u>0){const t=e.slice(a[u-1][1]);e=a.reduce(((t,n,s,l)=>{r&&(i=20+Math.floor(s/u*80),i!==o&&(o=i,r(i)));return t+e.slice(0===s?0:l[s-1][1],l[s][0])+(l[s][2]||"")}),""),e+=t}return e}function ve(e,t,r){if(t!=t)return function(e,t,r,n){for(var i=e.length,o=r+(n?1:-1);n?o--:++o<i;)if(t(e[o],o,e))return o;return-1}(e,_e,r);for(var n=r-1,i=e.length;++n<i;)if(e[n]===t)return n;return-1}function be(e,t,r,n){for(var i=r-1,o=e.length;++i<o;)if(n(e[i],t))return i;return-1}function _e(e){return e!=e}var we=Array.prototype.splice;function Oe(e,t,r,n){var i=n?be:ve,o=-1,s=t.length,l=e;for(e===t&&(t=function(e,t){var r=-1,n=e.length;t||(t=Array(n));for(;++r<n;)t[r]=e[r];return t}(t)),r&&(l=function(e,t){for(var r=-1,n=e?e.length:0,i=Array(n);++r<n;)i[r]=t(e[r],r,e);return i}(e,function(e){return function(t){return e(t)}}(r)));++o<s;)for(var a=0,u=t[o],c=r?r(u):u;(a=i(l,c,a,n))>-1;)l!==e&&we.call(l,a,1),we.call(e,a,1);return e}var Se=function(e,t){return e&&e.length&&t&&t.length?Oe(e,t):e};
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 5.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */function Ae(e,t=1){function r(e){return Array.from(e).reverse().join("")}function n(e,t,r){const n=r?"\n":"\r",i=r?"\r":"\n";if(!e)return e;let o=0,s="";for(let r=0,l=e.length;r<l;r++)(e[r]===n||e[r]===i&&e[r-1]!==n)&&o++,"\r\n".includes(e[r])||" "===e[r]?" "===e[r]?s+=e[r]:e[r]===n?o<=t&&(s+=e[r],e[r+1]===i&&(s+=e[r+1],r++)):e[r]===i&&(!e[r-1]||e[r-1]!==n)&&o<=t&&(s+=e[r]):e[r+1]||o||(s+=" ");return s}if("string"==typeof e&&e.length){let i=1;"number"==typeof+t&&Number.isInteger(+t)&&+t>=0&&(i=+t);let o="",s="";if(e.trim()){if(!e[0].trim())for(let t=0,r=e.length;t<r;t++)if(e[t].trim()){o=e.slice(0,t);break}}else o=e;if(e.trim()&&(""===e.slice(-1).trim()||" "===e.slice(-1)))for(let t=e.length;t--;)if(e[t].trim()){s=e.slice(t+1);break}return`${n(o,i,!1)}${e.trim()}${r(n(r(s),i,!0))}`}return e}
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 5.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */function Ce(e){return null!=e}function Ie(e){return Number.isInteger(e)&&e>=0}function Le(e){return"string"==typeof e}const $e={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1};class Me{constructor(e){const t={...$e,...e};if(t.mergeType&&1!==t.mergeType&&2!==t.mergeType)if(Le(t.mergeType)&&"1"===t.mergeType.trim())t.mergeType=1;else{if(!Le(t.mergeType)||"2"!==t.mergeType.trim())throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof t.mergeType}", equal to ${JSON.stringify(t.mergeType,null,4)}`);t.mergeType=2}this.opts=t,this.ranges=[]}add(e,t,r){if(null==e&&null==t)return;if(Ce(e)&&!Ce(t)){if(Array.isArray(e)){if(e.length){if(e.some((e=>Array.isArray(e))))return void e.forEach((e=>{Array.isArray(e)&&this.add(...e)}));e.length&&Ie(+e[0])&&Ie(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(t,null,0)})`)}if(!Ce(e)&&Ce(t))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(t,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);const n=+e,i=+t;if(Ie(r)&&(r=String(r)),!Ie(n)||!Ie(i))throw Ie(n)&&n>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n,null,4)}`);if(Ce(r)&&!Le(r)&&!Ie(r))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof r}, equal to:\n${JSON.stringify(r,null,4)}`);if(Ce(this.ranges)&&Array.isArray(this.last())&&n===this.last()[1]){if(this.last()[1]=i,this.last(),null!==this.last()[2]&&Ce(r)){let e=!(this.last()[2]&&this.last()[2].length>0)||this.opts&&this.opts.mergeType&&1!==this.opts.mergeType?r:this.last()[2]+r;this.opts.limitToBeAddedWhitespace&&(e=Ae(e,this.opts.limitLinebreaksCount)),Le(e)&&!e.length||(this.last()[2]=e)}}else{this.ranges||(this.ranges=[]);const e=void 0===r||Le(r)&&!r.length?[n,i]:[n,i,r&&this.opts.limitToBeAddedWhitespace?Ae(r,this.opts.limitLinebreaksCount):r];this.ranges.push(e)}}push(e,t,r){this.add(e,t,r)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=ye(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map((e=>Ce(e[2])?[e[0],e[1],Ae(e[2],this.opts.limitLinebreaksCount)]:e)):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length){if(!Array.isArray(e[0])||!Ie(e[0][0]))throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);this.ranges=Array.from(e)}else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}}
/**
 * @name html-crush
 * @fileoverview Minifies HTML/CSS: valid or broken, pure or mixed with other languages
 * @version 4.2.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/html-crush/}
 */const We=new Me({limitToBeAddedWhitespace:!0}),Re={lineLengthLimit:500,removeIndentations:!0,removeLineBreaks:!1,removeHTMLComments:!1,removeCSSComments:!0,reportProgressFunc:null,reportProgressFuncFrom:0,reportProgressFuncTo:100,breakToTheLeftOf:["</td","<html","</html","<head","</head","<meta","<link","<table","<script","</script","<!DOCTYPE","<style","</style","<title","<body","@media","</body","\x3c!--[if","\x3c!--<![endif","<![endif]"],mindTheInlineTags:["a","abbr","acronym","audio","b","bdi","bdo","big","br","button","canvas","cite","code","data","datalist","del","dfn","em","embed","i","iframe","img","input","ins","kbd","label","map","mark","meter","noscript","object","output","picture","progress","q","ruby","s","samp","script","select","slot","small","span","strong","sub","sup","svg","template","textarea","time","u","tt","var","video","wbr"]},je={removeHTMLComments:!1,removeCSSComments:!1};function xe(e){return"string"==typeof e}function Fe(e){return"string"==typeof e&&e.toUpperCase()!==e.toLowerCase()}function ke(e,t){const r=Date.now();if(!xe(e))throw void 0===e?new Error("html-crush: [THROW_ID_01] the first input argument is completely missing! It should be given as string."):new Error(`html-crush: [THROW_ID_02] the first input argument must be string! It was given as "${typeof e}", equal to:\n${JSON.stringify(e,null,4)}`);if(t&&"object"!=typeof t)throw new Error(`html-crush: [THROW_ID_03] the second input argument, options object, should be a plain object but it was given as type ${typeof t}, equal to ${JSON.stringify(t,null,4)}`);if(t&&Array.isArray(t.breakToTheLeftOf)&&t.breakToTheLeftOf.length)for(let e=0,r=t.breakToTheLeftOf.length;e<r;e++)if(!xe(t.breakToTheLeftOf[e]))throw new TypeError(`html-crush: [THROW_ID_05] the opts.breakToTheLeftOf array contains non-string elements! For example, element at index ${e} is of a type "${typeof t.breakToTheLeftOf[e]}" and is equal to:\n${JSON.stringify(t.breakToTheLeftOf[e],null,4)}`);const n={...Re,...t};"boolean"==typeof n.removeHTMLComments&&(n.removeHTMLComments=n.removeHTMLComments?1:0);let i="";Array.isArray(n.breakToTheLeftOf)&&n.breakToTheLeftOf.length&&(i=[...new Set(n.breakToTheLeftOf.map((e=>e[0])))].join(""));let o,s=null,c=null,h=!1,f=0,d=0,m=!1,y=!1,T=null,v=null,b=null,_=null,w=null,O=null,S=null,A=null,C=null,I=null;const L=">};",$="<",M="!",W=">",R="<",j="{},:;<>~+",x=j,F=j;let k=!0;const E=e.length,H=Math.floor(E/2);let N,P;n.reportProgressFunc&&(N=Math.floor(n.reportProgressFuncTo-.01*(n.reportProgressFuncTo-n.reportProgressFuncFrom)-n.reportProgressFuncFrom));let B=0,D="\n";if(e.includes("\r\n")?D="\r\n":e.includes("\r")&&(D="\r"),E){for(let t=0;t<E;t++)if(n.reportProgressFunc&&(E>1e3&&E<2e3?t===H&&n.reportProgressFunc(Math.floor((n.reportProgressFuncTo-n.reportProgressFuncFrom)/2)):E>=2e3&&(P=n.reportProgressFuncFrom+Math.floor(t/E*(N||1)),P!==B&&(B=P,n.reportProgressFunc(P)))),d++,o&&"number"==typeof o&&t>=o&&(o=void 0),null===_||!e.startsWith("</script",t)||Fe(e[t+8])){if(!o&&!m&&e.startsWith("<script",t)&&!Fe(e[t+7])){_=t,o=!0;let e="";(n.removeLineBreaks||n.removeIndentations)&&null!==c&&(c>0&&(e=D),We.push(c,t,e)),c=null,s=null}if(null!==C&&null===A&&!/\w/.test(e[t])){A=e.slice(C,t);const r=g(e,~-t);"number"==typeof r&&">"===e[r]&&!e[t].trim()&&g(e,t)?We.push(t,g(e,t)):r&&"/"===e[r]&&">"===e[g(e,r)]&&(!e[t].trim()&&g(e,t)&&We.push(t,g(e,t)),">"!==e[r+1]&&g(e,r+1)&&We.push(r+1,g(e,r+1)))}if(o||m||T||"<"!==e[~-t]||null!==C||(/\w/.test(e[t])?C=t:"/"===e[g(e,~-t)]&&/\w/.test(e[g(e,g(e,~-t))]||"")&&(C=g(e,g(e,~-t)))),o||!m&&!T||null===v||"*"!==e[t]||"/"!==e[t+1]||([w,O]=he({str:e,from:v,to:t+2,ifLeftSideIncludesThisThenCropTightly:x,ifRightSideIncludesThisThenCropTightly:F}),v=null,null!=w?We.push(w,O):(f+=1,t+=1),o=t+2),o||!m&&!T||null!==v||"/"!==e[t]||"*"!==e[t+1]||(je.removeCSSComments||(je.removeCSSComments=!0),n.removeCSSComments&&(v=t)),y&&e.startsWith("![endif",t+1)&&(y=!1),!o&&!m&&!T&&null!==b){let r;e.startsWith("--\x3e",t)?r=3:">"===e[t]&&"]"===e[t-1]&&(r=1),r&&([w,O]=he({str:e,from:b,to:t+r}),b=null,null!=w?n.lineLengthLimit&&d-(O-w)>=n.lineLengthLimit?(We.push(w,O,D),d=-r):(We.push(w,O),d-=O-w):(f+=r-1,t+=r-1),o=t+r)}if(o||m||T||!e.startsWith("\x3c!--",t)||null!==b||(e.startsWith("[if",t+4)?(y||(y=!0),2===n.removeHTMLComments&&(b=t)):!n.removeHTMLComments||y&&2!==n.removeHTMLComments||(b=t),je.removeHTMLComments||(je.removeHTMLComments=!0)),!o&&m&&null===v&&e.startsWith("</style",t)&&!Fe(e[t+7])?m=!1:o||m||null!==v||!e.startsWith("<style",t)||Fe(e[t+6])||(m=!0,(n.removeLineBreaks||n.removeIndentations)&&n.breakToTheLeftOf.includes("<style")&&e.startsWith(' type="text/css">',t+6)&&e[t+24]&&We.push(t+23,t+23,D)),!o&&!T&&"\"'".includes(e[t])&&e.endsWith("style=",t)&&(T=t),o||e[t].trim()){if(!o&&(!m&&!T||null===v)){if(null!==c){if(n.removeLineBreaks&&(f+=1),k)k=!1,(n.removeIndentations||n.removeLineBreaks)&&We.push(0,t);else if(n.removeIndentations&&!n.removeLineBreaks&&(!h&&null!==s&&t>s?We.push(s+1,t):c+1<t&&(e.endsWith("]>",c)||e.endsWith("--\x3e",c)||e.startsWith("<![",t)||e.startsWith("\x3c!--<![",t)?We.push(c,t):" "===e[c]?We.push(c+1,t):" "===e[~-t]?We.push(c,~-t):We.push(c,t," "))),n.removeLineBreaks||T){if(i.includes(e[t])&&a(e,t,n.breakToTheLeftOf)){"\r\n".includes(e[~-t])&&c===~-t||"\n"===e[~-t]&&"\r"===e[t-2]&&c===t-2||We.push(c,t,D),w=null,O=null,S=null,c=null,f=1;continue}let r=" ";"<"===e[t]&&u(e,t,n.mindTheInlineTags,{cb:e=>!e||!/\w/.test(e)})||(e[~-c]&&W.includes(e[~-c])&&R.includes(e[t])||(m||T)&&null===v&&(x.includes(e[~-c])||F.includes(e[t]))||e.startsWith("!important",t)&&!y||T&&("'"===e[~-c]||'"'===e[~-c])||"}"===e[~-c]&&e.startsWith("</style",t)||">"===e[t]&&("'\"".includes(e[p(e,t)])||"<"===e[g(e,t)])||"/"===e[t]&&">"===e[g(e,t)])&&(r="","/"===e[t]&&">"===e[t+1]&&g(e,t)&&g(e,t)>t+1&&(We.push(t+1,g(e,t)),f-=g(e,t)-t+1)),r&&r.length&&(f+=1),n.lineLengthLimit?f>=n.lineLengthLimit||!e[t+1]||">"===e[t]||"/"===e[t]&&">"===e[t+1]?((f>n.lineLengthLimit||f===n.lineLengthLimit&&e[t+1]&&e[t+1].trim()&&!L.includes(e[t])&&!$.includes(e[t+1]))&&(r=D,f=1),(f>n.lineLengthLimit||" "!==r||t!==c+1)&&(We.push(c,t,r),s=null),w=null,O=null,S=null):(null===w||c<w)&&(w=c,O=t,S=r):t===c+1&&" "===r||We.push(c,t,r)}c=null,h||(h=!0)}else k&&(k=!1),n.removeLineBreaks&&(f+=1);h||(h=!0)}}else null===c&&(c=t);if(!o&&!k&&0!==t&&n.removeLineBreaks&&(n.lineLengthLimit||i)&&!e.startsWith("</a",t)){if(i&&a(e,t,n.breakToTheLeftOf)&&e.slice(0,t).trim()&&(!e.startsWith("<![endif]",t)||!l(e,t,"\x3c!--"))){We.push(t,t,D),w=null,O=null,S=null,f=1;continue}if(n.lineLengthLimit&&f<=n.lineLengthLimit){if(!e[t+1]||$.includes(e[t])&&!M.includes(e[t])||L.includes(e[t])||!e[t].trim()){if(null!==w&&null!==O&&(w!==O||S&&S.length)){let r=S;e[t].trim()&&e[t+1]&&e[t+1].trim()&&f+(S?S.length:0)>n.lineLengthLimit&&(r=D),f+(r?r.length:0)>n.lineLengthLimit||" "!==r||O!==w+1||" "!==e[w]?"}"===e[~-w]&&"{"===e[O]||(We.push(w,O,r),s=null):f-=s||0}!(e[t].trim()&&($.includes(e[t])||e[~-t]&&L.includes(e[~-t]))&&xe(I))||A&&n.mindTheInlineTags.includes(A)||"<"===e[t]&&u(e,t,n.mindTheInlineTags,{cb:e=>!e||!/\w/.test(e)})||"<"===e[t]&&u(e,t,n.mindTheInlineTags,{trimCharsBeforeMatching:"/",cb:e=>!e||!/\w/.test(e)})?null!==v||null===w||!(T||!n.mindTheInlineTags||!Array.isArray(n.mindTheInlineTags)||Array.isArray(n.mindTheInlineTags.length)&&!n.mindTheInlineTags.length||!xe(A)||Array.isArray(n.mindTheInlineTags)&&n.mindTheInlineTags.length&&xe(A)&&!n.mindTheInlineTags.includes(A))||"<"===e[t]&&u(e,t,n.mindTheInlineTags,{trimCharsBeforeMatching:"/",cb:e=>!e||!/\w/.test(e)})||(w=null,O=null,S=null):(w=t,O=t,S=null)}}else if(n.lineLengthLimit)if(!$.includes(e[t])||"<"===e[t]&&u(e,t,n.mindTheInlineTags,{trimCharsBeforeMatching:"/",cb:e=>!e||!/\w/.test(e)}))e[t+1]&&L.includes(e[t])&&xe(A)&&Array.isArray(n.mindTheInlineTags)&&n.mindTheInlineTags.length&&!n.mindTheInlineTags.includes(A)?null!==w&&null!==O&&(w!==O||S&&S.length)||(We.push(t+1,t+1,D),f=0):e[t].trim()&&(e[t+1]||null!==w&&null!==O&&(w!==O||S&&S.length)&&We.push(w,O,D));else if(null!==w&&null!==O&&(w!==O||S&&S.length)){const e=S&&S.length?S.length:0;f-(O-w-e)-1>n.lineLengthLimit||(We.push(w,O,S),f-(O-w-e)-1===n.lineLengthLimit&&(We.push(t,t,D),f=0),w=null,O=null,S=null)}else We.push(t,t,D),f=0}if(!o&&!k&&n.removeLineBreaks&&n.lineLengthLimit&&f>=n.lineLengthLimit&&null!==w&&null!==O&&!L.includes(e[t])&&!$.includes(e[t])&&!"/".includes(e[t])&&(f!==n.lineLengthLimit||!e[t+1]||e[t+1].trim())){let r=D;e[t+1]&&!e[t+1].trim()&&f===n.lineLengthLimit&&(r=S),r===D&&!e[~-w].trim()&&p(e,w)&&(w=p(e,w)+1),We.push(w,O,r),f=t-O,e[t].length&&(f+=1),w=null,O=null,S=null}if((!o&&"\n"===e[t]||"\r"===e[t]&&(!e[t+1]||e[t+1]&&"\n"!==e[t+1]))&&(s=t,h&&(h=!1),!n.removeLineBreaks&&null!==c&&c<t&&e[t+1]&&"\r"!==e[t+1]&&"\n"!==e[t+1]&&We.push(c,t)),e[t+1]||(m&&null!==v?We.push(...he({str:e,from:v,to:t,ifLeftSideIncludesThisThenCropTightly:x,ifRightSideIncludesThisThenCropTightly:F})):c&&"\n"!==e[t]&&"\r"!==e[t]?We.push(c,t+1):c&&("\r"===e[t]&&"\n"===e[t+1]||"\n"===e[t]&&"\r"!==e[t-1])&&We.push(c,t)),!o&&T&&T<t&&e[T]===e[t]&&(T=null),!o&&!m&&e.startsWith("<pre",t)&&!Fe(e[t+4])){const r=e.indexOf("</pre",t+5);r>0&&(o=r)}if(!o&&!m&&e.startsWith("<code",t)&&!Fe(e[t+5])){const r=e.indexOf("</code",t+5);r>0&&(o=r)}if(!o&&e.startsWith("<![CDATA[",t)){const r=e.indexOf("]]>",t+9);r>0&&(o=r)}o||m||T||null===C||">"!==e[t]||("<"===e[g(e,t)]&&(I=A),C=null,A=null),"<"===e[t]&&null!==I&&(I=null)}else{if((n.removeIndentations||n.removeLineBreaks)&&t>0&&e[~-t]&&!e[~-t].trim())for(let r=t;r--;)if("\n"===e[r]||"\r"===e[r]||e[r].trim()){r+1<t&&We.push(r+1,t);break}_=null,o=!1,t+=8}if(We.current()){const t=We.current();We.wipe();const i=n.reportProgressFuncTo-.01*(n.reportProgressFuncTo-n.reportProgressFuncFrom),o=Te(e,t,(e=>{n.reportProgressFunc&&E>=2e3&&(P=Math.floor(i+e/100*(n.reportProgressFuncTo-i)),P!==B&&(B=P,n.reportProgressFunc(P)))})),s=o.length;return{log:{timeTakenInMilliseconds:Date.now()-r,originalLength:E,cleanedLength:s,bytesSaved:Math.max(E-s,0),percentageReducedOfOriginal:E?Math.round(100*Math.max(E-s,0)/E):0},ranges:t,applicableOpts:je,result:o}}}return{log:{timeTakenInMilliseconds:Date.now()-r,originalLength:E,cleanedLength:E,bytesSaved:0,percentageReducedOfOriginal:0},applicableOpts:je,ranges:null,result:e}}var Ee="__lodash_hash_undefined__",He="[object Function]",Ne="[object GeneratorFunction]",Pe=/^\[object .+?Constructor\]$/,Be="object"==typeof self&&self&&self.Object===Object&&self,De="object"==typeof c&&c&&c.Object===Object&&c||Be||Function("return this")();function Je(e,t){return!!(e?e.length:0)&&function(e,t,r){if(t!=t)return function(e,t,r,n){var i=e.length,o=r+(n?1:-1);for(;n?o--:++o<i;)if(t(e[o],o,e))return o;return-1}(e,ze,r);var n=r-1,i=e.length;for(;++n<i;)if(e[n]===t)return n;return-1}(e,t,0)>-1}function qe(e,t,r){for(var n=-1,i=e?e.length:0;++n<i;)if(r(t,e[n]))return!0;return!1}function ze(e){return e!=e}function Ue(e,t){return e.has(t)}function Ge(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}var Ve=Array.prototype,Ze=Function.prototype,Ye=Object.prototype,Ke=De["__core-js_shared__"],Qe=function(){var e=/[^.]+$/.exec(Ke&&Ke.keys&&Ke.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),Xe=Ze.toString,et=Ye.hasOwnProperty,tt=Ye.toString,rt=RegExp("^"+Xe.call(et).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),nt=Ve.splice,it=dt(De,"Map"),ot=dt(De,"Set"),st=dt(Object,"create");function lt(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function at(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function ut(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function ct(e){var t=-1,r=e?e.length:0;for(this.__data__=new ut;++t<r;)this.add(e[t])}function ht(e,t){for(var r,n,i=e.length;i--;)if((r=e[i][0])===(n=t)||r!=r&&n!=n)return i;return-1}function ft(e){return!(!mt(e)||function(e){return!!Qe&&Qe in e}(e))&&(function(e){var t=mt(e)?tt.call(e):"";return t==He||t==Ne}(e)||function(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}(e)?rt:Pe).test(function(e){if(null!=e){try{return Xe.call(e)}catch(e){}try{return e+""}catch(e){}}return""}(e))}lt.prototype.clear=function(){this.__data__=st?st(null):{}},lt.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},lt.prototype.get=function(e){var t=this.__data__;if(st){var r=t[e];return r===Ee?void 0:r}return et.call(t,e)?t[e]:void 0},lt.prototype.has=function(e){var t=this.__data__;return st?void 0!==t[e]:et.call(t,e)},lt.prototype.set=function(e,t){return this.__data__[e]=st&&void 0===t?Ee:t,this},at.prototype.clear=function(){this.__data__=[]},at.prototype.delete=function(e){var t=this.__data__,r=ht(t,e);return!(r<0)&&(r==t.length-1?t.pop():nt.call(t,r,1),!0)},at.prototype.get=function(e){var t=this.__data__,r=ht(t,e);return r<0?void 0:t[r][1]},at.prototype.has=function(e){return ht(this.__data__,e)>-1},at.prototype.set=function(e,t){var r=this.__data__,n=ht(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},ut.prototype.clear=function(){this.__data__={hash:new lt,map:new(it||at),string:new lt}},ut.prototype.delete=function(e){return pt(this,e).delete(e)},ut.prototype.get=function(e){return pt(this,e).get(e)},ut.prototype.has=function(e){return pt(this,e).has(e)},ut.prototype.set=function(e,t){return pt(this,e).set(e,t),this},ct.prototype.add=ct.prototype.push=function(e){return this.__data__.set(e,Ee),this},ct.prototype.has=function(e){return this.__data__.has(e)};var gt=ot&&1/Ge(new ot([,-0]))[1]==1/0?function(e){return new ot(e)}:function(){};function pt(e,t){var r,n,i=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?i["string"==typeof t?"string":"hash"]:i.map}function dt(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return ft(r)?r:void 0}function mt(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}var yt=function(e){return e&&e.length?function(e,t,r){var n=-1,i=Je,o=e.length,s=!0,l=[],a=l;if(r)s=!1,i=qe;else if(o>=200){var u=t?null:gt(e);if(u)return Ge(u);s=!1,i=Ue,a=new ct}else a=t?[]:l;e:for(;++n<o;){var c=e[n],h=t?t(c):c;if(c=r||0!==c?c:0,s&&h==h){for(var f=a.length;f--;)if(a[f]===h)continue e;t&&a.push(h),l.push(c)}else i(a,h,r)||(a!==l&&a.push(h),l.push(c))}return l}(e):[]};const Tt=/[\n]?\s*<style[^>]*>\s*<\/style\s*>/g,vt=/[\n]?\s*@(media|supports|document)[^{]*{\s*}/g,bt=/@media[^{@}]+{(?=\s*<\/style>)/g;function _t(e){return e&&"object"==typeof e&&!Array.isArray(e)}function wt(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function Ot(e){return"string"==typeof e&&1===e.length&&(e.charCodeAt(0)>64&&e.charCodeAt(0)<91||e.charCodeAt(0)>96&&e.charCodeAt(0)<123)}const St={whitelist:[],backend:[],uglify:!1,removeHTMLComments:!0,removeCSSComments:!0,doNotRemoveHTMLCommentsWhoseOpeningTagContains:["[if","[endif"],reportProgressFunc:null,reportProgressFuncFrom:0,reportProgressFuncTo:100};e.comb=function(e,t){const r=Date.now(),n=new Me({limitToBeAddedWhitespace:!0}),i=new Me,o=new Me;function s(e){return/[-_A-Za-z0-9]/.test(e)}function c(e={}){return{valuesStart:null,valueStart:null,nameStart:null,quoteless:!1,...e}}let h,f;const m=[],y=[],T=[];let v,b,O,S,A;const C={};let I,L,$,M,W,R,j,x,F,k,E,H=0,N=null,P=[],B=0,D=0,J=0,q=!1,z=null,U=!1,G=0,V=0;const Z=".# ~\\!@$%^&*()+=,/';:\"?><[]{}|`\t\n",Y=["media","supports","document"],K=["font-feature-values","counter-style","namespace","font-face","keyframes","viewport","charset","import","page"],Q=["{","(","<",'"',"'","@",";"];if("string"!=typeof e)throw new TypeError("email-comb: [THROW_ID_01] Input must be string! Currently it's "+typeof e);if(t&&!_t(t))throw new TypeError(`email-comb: [THROW_ID_02] Options, second input argument, must be a plain object! Currently it's ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);const X={...St,...t};if("string"==typeof X.doNotRemoveHTMLCommentsWhoseOpeningTagContains&&(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains=[X.doNotRemoveHTMLCommentsWhoseOpeningTagContains].filter((e=>e.trim()))),"string"==typeof X.whitelist)X.whitelist=[X.whitelist];else if(!Array.isArray(X.whitelist))throw new TypeError(`email-comb: [THROW_ID_03] opts.whitelist should be an array, but it was customised to a wrong thing, ${JSON.stringify(X.whitelist,null,4)}`);if(X.whitelist.length>0&&!X.whitelist.every((e=>"string"==typeof e)))throw new TypeError(`email-comb: [THROW_ID_04] opts.whitelist array should contain only string-type elements. Currently we\ve got:\n${JSON.stringify(X.whitelist,null,4)}`);if(!Array.isArray(X.backend))throw new TypeError(`email-comb: [THROW_ID_05] opts.backend should be an array, but it was customised to a wrong thing, ${JSON.stringify(X.backend,null,4)}`);if(X.backend.length>0&&X.backend.some((e=>!_t(e))))throw new TypeError(`email-comb: [THROW_ID_06] opts.backend array should contain only plain objects but it contains something else:\n${JSON.stringify(X.backend,null,4)}`);if(X.backend.length>0&&!X.backend.every((e=>wt(e,"heads")&&wt(e,"tails"))))throw new TypeError(`email-comb: [THROW_ID_07] every object within opts.backend should contain keys "heads" and "tails" but currently it's not the case. Whole "opts.backend" value array is currently equal to:\n${JSON.stringify(X.backend,null,4)}`);if("boolean"!=typeof X.uglify){if(1!==X.uglify&&0!==X.uglify)throw new TypeError(`email-comb: [THROW_ID_08] opts.uglify should be a Boolean. Currently it's set to: ${JSON.stringify(X.uglify,null,4)}}`);X.uglify=!!X.uglify}if(X.reportProgressFunc&&"function"!=typeof X.reportProgressFunc)throw new TypeError(`email-comb: [THROW_ID_09] opts.reportProgressFunc should be a function but it was given as :\n${JSON.stringify(X.reportProgressFunc,null,4)} (${typeof X.reportProgressFunc})`);let ee=null,te=null;Array.isArray(X.backend)&&X.backend.length&&(ee=X.backend.map((e=>e.heads)),te=X.backend.map((e=>e.tails)));const re=e.length;let ne=1;X.reportProgressFunc&&(ne=Math.floor((X.reportProgressFuncTo-.06*(X.reportProgressFuncTo-X.reportProgressFuncFrom)-X.reportProgressFuncFrom)/2));let ie,oe,se=0;e.length&&"\r\n".includes(e[e.length-1])||(se=1);let le,ae,ce,fe,pe,de,me,ye,ve=[],be=[],_e=[],we=[],Oe={},Ae=[],Ce=0,Ie=[],Le=[],$e=[];for(let t=1;t<=2;t++){I=!1,R=null,q=!1,k=!0,F=!0,S=c(),$=!0,U=!1,j=null,A=c(),b=null,z=null,ce=null,ae=!1,fe=null,L=!1,W=null,pe=!1,v=null,oe=null,h=null,O=null,de=null,f=null,ie=!1,H+=re;e:for(let r=0;r<re;r++){X.reportProgressFunc&&(re>1e3&&re<2e3?1===t&&0===r&&X.reportProgressFunc(Math.floor((X.reportProgressFuncTo-X.reportProgressFuncFrom)/2)):re>=2e3&&(le=X.reportProgressFuncFrom+Math.floor(r/re*ne)+(1===t?0:ne),le!==Ce&&(Ce=le,X.reportProgressFunc(le))));const o=e[r];if(!0!==ae&&(null===f&&null!==h&&r>=h||null!==h&&null!==f&&h>f&&h<r)?(ae=!0,pe=!1):!0!==pe&&null!==O&&(null===h||h<r)&&(null===f||f<r)&&(pe=!0,ae=!1),!ie&&('"'===e[r]||"'"===e[r]))if(ce){if('"'===e[r]&&"'"===e[g(e,r)]&&'"'===e[g(e,g(e,r))]||"'"===e[r]&&'"'===e[g(e,r)]&&"'"===e[g(e,g(e,r))]){r=g(e,g(e,r));continue}ce===e[r]&&(ce=null)}else{const t=p(e,r);"number"==typeof t&&(ae&&["(",",",":"].includes(e[t])||pe&&!ae&&["(",",",":","="].includes(e[t]))&&(ce=e[r])}if(ie)if(null===oe||"string"!=typeof oe||"string"==typeof oe&&!oe)ie=!1;else if(a(e,r,oe)){if(null!==v){if(1===t&&X.removeCSSComments){const t=l(e,v,["\r\n","\n","\r"]);let i=v;"string"==typeof t&&t.length&&(i-=t.length),e[i-1]&&s(e[i-1])&&e[r+oe.length]&&s(e[r+oe.length])?(n.push(i,r+oe.length,";"),V+=r+oe.length-i):(n.push(i,r+oe.length),V+=r+oe.length-i)}v=null}r=r+oe.length-1,oe=null,ie=!1;continue}if(!ie&&"<"===e[r]&&"s"===e[r+1]&&"t"===e[r+2]&&"y"===e[r+3]&&"l"===e[r+4]&&"e"===e[r+5]){I=!0,ae||(ae=!0);for(let t=r;t<re;t++)if(H+=1,">"===e[t]){h=t+1,W=t+1;break}}if(!ie&&ae&&"<"===e[r]&&"/"===e[r+1]&&"s"===e[r+2]&&"t"===e[r+3]&&"y"===e[r+4]&&"l"===e[r+5]&&"e"===e[r+6]&&(f=r-1,W=null,I=!1,ae&&(ae=!1)),1!==t||!ae&&!pe||"/"!==e[r]||"*"!==e[r+1]||null!==v){if(!ie&&ae&&"@"===e[r]){fe&&(fe=null);const i=u(e,r,Y)||u(e,r,K);if("string"==typeof i){let o,s;(";"===e[r+i.length+1]||e[r+i.length+1]&&!e[r+i.length+1].trim()&&u(e,r+i.length+1,";",{trimBeforeMatching:!0,cb:(e,t,r)=>(o=r,!0)}))&&n.push(r,o||r+i.length+2);for(let o=r+1;o<re;o++){H+=1;let l="";if("{"===e[o]&&"{"===e[o+1]&&(l="}}"),"{"===e[o]&&"%"===e[o+1]&&(l="%}"),l&&e.includes(l,o+1))o=e.indexOf(l,o+1)+l.length-1;else if(l&&(l=""),s&&e[o]===s){if("}"===e[o]&&K.includes(i)||"{"===e[o]&&Y.includes(i)){r=o,W=o+1;continue e}s=void 0}else if('"'!==e[o]||s?"'"!==e[o]||s?"("!==e[o]||s?K.includes(i)&&"{"===e[o]&&!s&&(s="}"):s=")":s="'":s='"',!s&&Q.includes(e[o])){let i,s;if("{"===e[o]||";"===e[o]){L=!1,W=o+1,r=o;continue e}"@"!==e[o]&&"<"!==e[o]||1!==t||e.slice(r,o).includes("{")||e.slice(r,o).includes("(")||e.slice(r,o).includes('"')||e.slice(r,o).includes("'")||(i=r,s=o+(";"===e[o]?1:0),n.push(i,s));const l=s?s-1:o-1+("{"===e[o]?1:0);r=l,W=l+1;continue e}}}}if(!ie&&ae&&L&&I&&"}"===o&&!ce&&!J&&(2===t&&F&&W&&n.push(W,r+1),L=!1,W&&(W=r+1),R=null,q=!1,F=!0,j=null,z=null,U=!1),!ie&&!v&&h&&r>=h&&(null===f&&r>=h||f&&h>f&&h<=r)&&!L){if(null===j){if("."===o||"#"===o)j=r;else if(l(e,r,"[class="))Ot(o)?(j=r,x="."):"\"'".includes(o)&&Ot(e[g(e,r)])&&(j=g(e,r),x=".");else if(l(e,r,"[id="))Ot(o)?(j=r,x="#"):"\"'".includes(o)&&Ot(e[g(e,r)])&&(j=g(e,r),x="#");else if(o.trim())if("}"===o)W=r+1,de=null;else if("<"===o&&"!"===e[r+1])for(let t=r;t<re;t++)if(H+=1,">"===e[t]){W=t+1,R=t+1,r=t;continue e}}else if(null!==j&&!s(o)){let n=e.slice(j,r);x&&(n=`${x}${n}`,x=void 0),2===t&&!q&&$e.includes(n)?(q=!0,U=!0):2!==t||q||(!X.uglify||Array.isArray(X.whitelist)&&X.whitelist.length&&_([n],X.whitelist).length||i.push(j,r,P[be.indexOf(n)]),","===o&&(z=r,U=!1)),j="."===o||"#"===o?r:null}if(null===R)!o.trim()||"}"===o||";"===o||"/"===e[r]&&"*"===e[r+1]||(q=!1,R=r);else if(",{".includes(o)){if(de=e.slice(R,fe||r),1===t)fe&&(","===o&&fe<r?(n.push(fe,r),G+=r-fe):"{"===o&&fe<r-1&&(n.push(fe,r-1),G+=r-1-fe)),m.push(de);else if(q){let t=R,s=r,a=0;if("{"===o&&">"!==e[t-1]&&"}"!==e[t-1]){for(let r=R;r--;)if(H+=1,e[r].trim()&&","!==e[r]){t=r+1;break}e[r-1].trim()||(s=r-1)}else if(","!==o||e[r+1].trim())l(e,t,"{",{trimBeforeMatching:!0,cb:(e,t,r)=>(a=r,!0)})&&(t=a+2);else for(let t=r+1;t<re;t++)if(H+=1,e[t].trim()){s=t;break}const u=he({str:e,from:t,to:s,ifRightSideIncludesThisThenCropTightly:".#",ifRightSideIncludesThisCropItToo:",",extendToOneSide:"right"});n.push(...u),X.uglify&&i.wipe()}else F&&(F=!1),U&&(U=!1),X.uglify&&(n.push(i.current()),i.wipe());if("{"!==o)R=null;else if(2===t&&!F&&null!==z&&U){let t=z+1;if("\n\r".includes(e[z+1]))for(let r=z+1;r<re;r++)if(e[r].trim()){t=r;break}n.push(z,t),z=null,U=!1}}}if(!ie&&!ae&&pe&&"/"===e[r]&&u(e,r,"body",{trimBeforeMatching:!0,i:!0})&&l(e,r,"<",{trimBeforeMatching:!0})&&(pe=!1,O=null),!ie&&"<"===e[r]&&u(e,r,"body",{i:!0,trimBeforeMatching:!0,cb:(e,i,o)=>{if(1===t){if(void 0!==e&&(""===e.trim()||">"===e)&&"number"==typeof o){if(!(o-r>5))return!0;n.push(r,o,"<body"),G+=o-r-5}return!0}return!0}}))for(let t=r;t<re;t++)if(H+=1,">"===e[t]){O=t+1;break}if(!ie&&pe&&!ae&&"s"===e[r]&&"t"===e[r+1]&&"y"===e[r+2]&&"l"===e[r+3]&&"e"===e[r+4]&&"="===e[r+5]&&Z.includes(e[r-1])&&"\"'".includes(e[r+6]),!ie&&pe&&!ae&&!ce&&"c"===e[r]&&"l"===e[r+1]&&"a"===e[r+2]&&"s"===e[r+3]&&"s"===e[r+4]&&e[r-1]&&!e[r-1].trim()){let i,o=!1;if("="===e[r+5]){if('"'===e[r+6]||"'"===e[r+6])i=r+7;else if(s(e[r+6]))i=r+6,o=!0;else if(e[r+6]&&(!e[r+6].trim()||"/>".includes(e[r+6]))){const t=he({str:e,from:r,to:r+6,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0});n.push(...t)}}else if(!e[r+5].trim())for(let o=r+5;o<re;o++)if(H+=1,e[o].trim()){if("="===e[o])if(o>r+5&&1===t&&n.push(r+5,o),'"'!==e[o+1]&&"'"!==e[o+1]||!e[o+2]){if(e[o+1]&&!e[o+1].trim())for(let r=o+1;r<re;r++)if(H+=1,e[r].trim()){r>o+1&&1===t&&n.push(o+1,r),'"'!==e[r]&&"'"!==e[r]||!e[r+1]||(i=r+1);break}}else i=o+2;break}i&&(S=c({valuesStart:i,quoteless:o,nameStart:r}),1===t?$=!0:2===t&&(k=!0))}if(!ie&&pe&&!ae&&!ce&&"i"===e[r]&&"d"===e[r+1]&&e[r-1]&&!e[r-1].trim()){let i,o=!1;if("="===e[r+2]){if('"'===e[r+3]||"'"===e[r+3])i=r+4;else if(s(e[r+3]))i=r+3,o=!0;else if(e[r+3]&&(!e[r+3].trim()||"/>".includes(e[r+3]))){const t=he({str:e,from:r,to:r+3,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0});n.push(...t)}}else if(!e[r+2].trim())for(let o=r+2;o<re;o++)if(H+=1,e[o].trim()){if("="===e[o])if(o>r+2&&1===t&&n.push(r+2,o),'"'!==e[o+1]&&"'"!==e[o+1]||!e[o+2]){if(e[o+1]&&!e[o+1].trim())for(let r=o+1;r<re;r++)if(H+=1,e[r].trim()){r>o+1&&1===t&&n.push(o+1,r),'"'!==e[r]&&"'"!==e[r]||!e[r+1]||(i=r+1);break}}else i=o+2;break}i&&(A=c({valuesStart:i,quoteless:o,nameStart:r}),1===t?$=!0:2===t&&(k=!0))}if(!ie&&null!==S.valuesStart&&r>=S.valuesStart&&null===S.valueStart)if(ee&&a(e,r,ee)){if(ie=!0,k=!1,fe&&r>fe+1){const t=he({str:e,from:fe,to:r,ifLeftSideIncludesThisThenCropTightly:"\"'",ifRightSideIncludesThisThenCropTightly:"\"'"});n.push(...t),fe=null}else fe&&(fe=null);const t=a(e,r,ee),i=X.backend.find((e=>e.heads===t));i&&i.tails&&(oe=i.tails)}else s(o)&&(S.valueStart=r,1===t&&($&&null!==S.valuesStart&&!e.slice(S.valuesStart,r).trim()&&S.valuesStart<r?(n.push(S.valuesStart,r),G+=r-S.valuesStart,$=!1):null!==fe&&fe<r-1&&(n.push(fe+1,r),G+=r-fe+1)));if(!ie&&null!==S.valueStart&&r>S.valueStart&&(!s(o)||te&&a(e,r,te)))if(ee&&a(e,r,ee)){S.valueStart=null,S=c();const t=a(e,r,ee),n=X.backend.find((e=>e.heads===t));n&&n.tails&&(oe=n.tails)}else{const i=`${e.slice(S.valueStart,r)}`;if(1===t)y.push(`.${i}`);else if(null!=S.valueStart&&Ae.includes(i)){const t=he({str:e,from:S.valueStart,to:r,ifLeftSideIncludesThisThenCropTightly:"\"'",ifRightSideIncludesThisThenCropTightly:"\"'",wipeAllWhitespaceOnLeft:!0});let i="";e[t[0]-1]&&e[t[0]-1].trim()&&e[t[1]]&&e[t[1]].trim()&&(ee||te)&&(ee&&l(e,t[0],te)||te&&a(e,t[1],ee))&&(i=" "),n.push(...t,i)}else k=!1,!X.uglify||Array.isArray(X.whitelist)&&X.whitelist.length&&_([`.${i}`],X.whitelist).length||n.push(S.valueStart,r,P[be.indexOf(`.${i}`)].slice(1));S.valueStart=null}if(!ie&&A&&null!==A.valueStart&&r>A.valueStart&&(!s(o)||te&&a(e,r,te))){const i=e.slice(A.valueStart,r);if(1===t)T.push(`#${i}`);else if(null!=A.valueStart&&Ie.includes(i)){const t=he({str:e,from:A.valueStart,to:r,ifRightSideIncludesThisThenCropTightly:"\"'",wipeAllWhitespaceOnLeft:!0});e[t[0]-1]&&e[t[0]-1].trim()&&e[t[1]]&&e[t[1]].trim()&&(ee||te)&&(ee&&l(e,t[0],te||[])||te&&a(e,t[1],ee||[]))&&(t[0]+=1),n.push(...t)}else k=!1,!X.uglify||Array.isArray(X.whitelist)&&X.whitelist.length&&_([`#${i}`],X.whitelist).length||n.push(A.valueStart,r,P[be.indexOf(`#${i}`)].slice(1));A.valueStart=null}if(!ie&&null!=S.valuesStart&&(!S.quoteless&&("'"===o||'"'===o)||S.quoteless&&!s(e[r]))&&r>=S.valuesStart){if(r===S.valuesStart)1===t&&n.push(...he({str:e,from:S.nameStart,to:r+1,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0}));else{if(2===t&&k){const t=he({str:e,from:S.valuesStart-7,to:"'\"".includes(e[r])?r+1:r,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0});let i="";e[t[0]-1]&&e[t[0]-1].trim()&&e[t[1]]&&e[t[1]].trim()&&!"/>".includes(e[t[1]])&&(i=" "),n.push(...t,i)}null!==fe&&n.push(fe,r)}S=c()}if(!ie&&null!==A.valuesStart&&(!A.quoteless&&("'"===o||'"'===o)||A.quoteless&&!s(e[r]))&&r>=A.valuesStart){if(r===A.valuesStart)1===t&&n.push(...he({str:e,from:A.nameStart,to:r+1,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0}));else{if(2===t&&k){const t=he({str:e,from:A.valuesStart-4,to:r+1,ifRightSideIncludesThisThenCropTightly:"/>",wipeAllWhitespaceOnLeft:!0});let i="";e[t[0]-1]&&e[t[0]-1].trim()&&e[t[1]]&&e[t[1]].trim()&&!"/>".includes(e[t[1]])&&(i=" "),n.push(...t,i)}null!==fe&&n.push(fe,r)}A=c()}if(!ie&&A.valuesStart&&r>=A.valuesStart&&null===A.valueStart)if(ee&&a(e,r,ee)){if(ie=!0,k=!1,fe&&r>fe+1){const t=he({str:e,from:fe,to:r,ifLeftSideIncludesThisThenCropTightly:"\"'",ifRightSideIncludesThisThenCropTightly:"\"'"});n.push(...t),fe=null}else fe&&(fe=null);const t=a(e,r,ee),i=X.backend.find((e=>e.heads===t));i&&i.tails&&(oe=i.tails)}else s(o)&&(A.valueStart=r,1===t&&($&&null!==A.valuesStart&&!e.slice(A.valuesStart,r).trim()&&A.valuesStart<r?(n.push(A.valuesStart,r),G+=r-A.valuesStart,$=!1):null!==fe&&fe<r-1&&(n.push(fe+1,r),G+=r-fe+1)));if(!ie&&1===t){if(null!==v&&v<r&&">"===e[r]&&!ye&&(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains&&Array.isArray(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains)&&X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.length&&X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.some((t=>t.trim()&&e.slice(v,r).toLowerCase().includes(t)))&&(me=!1),ye=!0),null!==v&&">"===e[r])if(M||"-"!==e[r-1]||"-"!==e[r-2]){if(M){const t=he({str:e,from:v,to:r+1,wipeAllWhitespaceOnLeft:!0,addSingleSpaceToPreventAccidentalConcatenation:!0});X.removeHTMLComments&&me&&n.push(...t),V+=t[1]-t[0],v=null,M=void 0}}else{const t=he({str:e,from:v,to:r+1,wipeAllWhitespaceOnLeft:!0,addSingleSpaceToPreventAccidentalConcatenation:!0});X.removeHTMLComments&&me&&n.push(...t),V+=t[1]-t[0],v=null,M=void 0}X.removeHTMLComments&&null===v&&"<"===e[r]&&"!"===e[r+1]&&((!ee||Array.isArray(ee)&&ee.length&&!ee.includes("<!"))&&(!te||Array.isArray(te)&&te.length&&!te.includes("<!"))&&(u(e,r+1,"doctype",{i:!0,trimBeforeMatching:!0})||"-"===e[r+2]&&"-"===e[r+3]&&Array.isArray(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains)&&X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.length&&u(e,r+3,X.doNotRemoveHTMLCommentsWhoseOpeningTagContains,{trimBeforeMatching:!0})||(v=r,ye=!1,me=!0),M=!("-"===e[r+2]&&"-"===e[r+3])),v!==r&&(b=r))}if("}"===o&&J&&(J-=1),!ie&&"{"===o&&I&&(L?J+=1:(L=!0,null!==fe&&(e.slice(fe,r).includes("\n")||e.slice(fe,r).includes("\r"))&&n.push(fe,r))),ie||(e[r].trim()?null!==fe&&(fe=null):null===fe&&(fe=r)),!ie&&2===t&&Array.isArray(E)&&E.length&&r===E[0][0]){const e=E.shift();e&&e[1]-1>r&&(r=e[1]-1)}else if(null!==b&&">"===e[r]){b=null;let t=0;if(X.removeHTMLComments&&Array.isArray(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains)&&X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.length&&(X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.some((e=>e.includes("if")))||X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.some((e=>e.includes("mso")))||X.doNotRemoveHTMLCommentsWhoseOpeningTagContains.some((e=>e.includes("ie"))))&&u(e,r,"\x3c!--",{trimBeforeMatching:!0,cb:(e,r,n)=>(t=n,!0)})){u(e,t-1,"--\x3e",{trimBeforeMatching:!0,cb:(e,r,n)=>(t=n,!0)}),"number"==typeof t&&(r=t-1);continue}}}else v=r,ie=!0,oe="*/",r+=1}if(1===t){we=yt(y.concat(T)),m.forEach((e=>{d(e).res.forEach((e=>{Object.prototype.hasOwnProperty.call(C,e)?C[e]+=1:C[e]=1}))})),Oe={...C},_e=yt(m.reduce(((e,t)=>e.concat(d(t).res)),[])),D=_e.length;const e=Array.from(m);let t,r=[];for(let t=0,n=e.length;t<n;t++){let i;H+=1,null!=e[t]&&(i=d(e[t]).res),i&&!i.every((e=>we.includes(e)))&&(r.push(...d(e[t]).res),e.splice(t,1),t-=1,n-=1)}r=yt(w(r,X.whitelist)),t=e&&e.length?e.reduce(((e,t)=>e.concat(d(t).res)),[]):[],$e=w(Se(yt(Array.from(_e)),y.concat(T)),X.whitelist),Le=yt(w(Se(y.concat(T),t),X.whitelist)),$e=yt($e.concat(ue(r,Le))),Ae=Le.filter((e=>e.startsWith("."))).map((e=>e.slice(1))),Ie=Le.filter((e=>e.startsWith("#"))).map((e=>e.slice(1))),ve=Object.keys(Oe).filter((e=>Oe[e]<1)),Ae=yt(Ae.concat(ue(w(we,X.whitelist),ve).filter((e=>"."===e[0])).map((e=>e.slice(1)))));const i=_(we,X.whitelist);Le=yt(Le.concat(Ae.map((e=>`.${e}`)),Ie.map((e=>`#${e}`)))),be=Se(Se(Array.from(_e),Le),$e),Array.isArray(i)&&i.length&&i.forEach((e=>{be.includes(e)||be.push(e)})),X.uglify&&(P=ge(be)),B=be.length,N=X.uglify?be.map(((e,t)=>[e,P[t]])).filter((e=>!X.whitelist.some((t=>_.isMatch(e[0],t))))):null,E=n.current()?Array.from(n.current()||[]):null}}n.push(o.current()),e.length&&n.current()&&(e=Te(e,n.current()),n.wipe());const We=X.reportProgressFuncTo-.06*(X.reportProgressFuncTo-X.reportProgressFuncFrom);for(X.reportProgressFunc&&re>=2e3&&(le=Math.floor(We+(X.reportProgressFuncTo-We)/5),le!==Ce&&(Ce=le,X.reportProgressFunc(le)));vt.test(e)||bt.test(e);)H+=(e=(e=e.replace(vt,"")).replace(bt,"")).length;X.reportProgressFunc&&re>=2e3&&(le=Math.floor(We+(X.reportProgressFuncTo-We)/5*2),le!==Ce&&(Ce=le,X.reportProgressFunc(le))),H+=(e=e.replace(Tt,"\n")).length,X.reportProgressFunc&&re>=2e3&&(le=Math.floor(We+(X.reportProgressFuncTo-We)/5*3),le!==Ce&&(Ce=le,X.reportProgressFunc(le)));let Re=e.length;return H+=(e=e.replace(/<!(--)?\[if[^\]]*]>[<>!-\s]*<!\[endif\]\1>/gi,"")).length,Re!==e.length&&(V+=e.length-Re),X.reportProgressFunc&&re>=2e3&&(le=Math.floor(We+(X.reportProgressFuncTo-We)/5*4),le!==Ce&&(Ce=le,X.reportProgressFunc(le))),Re=(e=ke(e,{removeLineBreaks:!1,removeIndentations:!1,removeHTMLComments:!1,removeCSSComments:!1,lineLengthLimit:500}).result).length,Re!==e.length&&(G+=e.length-Re),H+=e.length,X.reportProgressFunc&&re>=2e3&&(le=Math.floor(We+(X.reportProgressFuncTo-We)),le!==Ce&&(Ce=le,X.reportProgressFunc(le))),e.length&&(e[0].trim()&&e[e.length-1].trim()||e.length===e.trim().length||(G+=e.length-e.trim().length),e=e.trimStart()),e=e.replace(/ ((class|id)=["']) /g," $1"),{log:{timeTakenInMilliseconds:Date.now()-r,traversedTotalCharacters:H,traversedTimesInputLength:re?Math.round(H/re*100)/100:0,originalLength:re,cleanedLength:e.length,bytesSaved:Math.max(re-e.length,0),percentageReducedOfOriginal:re?Math.round(100*Math.max(re-e.length,0)/re):0,nonIndentationsWhitespaceLength:Math.max(G-se,0),nonIndentationsTakeUpPercentageOfOriginal:re&&Math.max(G-se,0)?Math.round(100*Math.max(G,0)/re):0,commentsLength:V,commentsTakeUpPercentageOfOriginal:re&&V?Math.round(100*V/re):0,uglified:N},result:e,countAfterCleaning:B,countBeforeCleaning:D,allInHead:_e.sort(),allInBody:we.sort(),deletedFromHead:$e.sort(),deletedFromBody:Le.sort()}},e.defaults=St,e.version="5.1.0",Object.defineProperty(e,"__esModule",{value:!0})}));
